#!/bin/sh

export CWMP_BUS_NAME="com.sangoma.cwmp.Service"
export CWMP_OBJ_PATH="/com/sangoma/cwmp/Service"

make_cwmp_buffer() {
    if [ -z "$2" ] ; then
        echo "$1"
    else
        echo "$1,$2"
    fi
}

cwmp_config() {
    databuffer=""

    if [ "x${new_cwmp_acs_url}" != x ] ; then
        itembuffer="acs_url,${new_cwmp_acs_url}"
        databuffer=`make_cwmp_buffer "$itembuffer" "$databuffer"`
    fi
    if [ "x${new_cwmp_provisioning_code}" != x ] ; then
        itembuffer="provisioning_code,${new_cwmp_provisioning_code}"
        databuffer=`make_cwmp_buffer "$itembuffer" "$databuffer"`
    fi
    if [ "x${new_cwmp_retry_minimum_wait_interval}" != x ] ; then
        itembuffer="retry_minimum_wait_interval,${new_cwmp_retry_minimum_wait_interval}"
        databuffer=`make_cwmp_buffer "$itembuffer" "$databuffer"`
    fi
    if [ "x${new_cwmp_retry_interval_multiplier}" != x ] ; then
        itembuffer="retry_interval_multiplier,${new_cwmp_retry_interval_multiplier}"
        databuffer=`make_cwmp_buffer "$itembuffer" "$databuffer"`
    fi

    /bin/dbus-send --system --type=method_call --dest="${CWMP_BUS_NAME}" \
            --print-reply --reply-timeout=15000 "${CWMP_OBJ_PATH}" \
            "${CWMP_BUS_NAME}.DhcpConfig" \
            "dict:string:string:$databuffer" >/dev/null
}

cwmp_restore() {
    /bin/dbus-send --system --type=method_call --dest="${CWMP_BUS_NAME}" \
            --print-reply --reply-timeout=15000 "${CWMP_OBJ_PATH}" \
            "${CWMP_BUS_NAME}.DhcpRestore" > /dev/null
}
