#!/bin/bash
#
# webconfig.sh: dhclient-script plugin for NTP settings,
#         place in /etc/dhcp/dhclient.d and 'chmod +x webconfig.sh' to enable
#
#

sng-dhcp-handler_config() {
	safe_db_file="/var/webconfig/SAFe/application/db/safe.db"
	if [ ! -z "$new_ip_address" -a "$new_ip_address" != "" ]; then
		ip_type=4
		file_name=/tmp/dhcp.$interface.$ip_type
		#delete the old file first, create new one json format
		rm -f $file_name
		echo "{" >> $file_name
		echo '"reason": "'$reason'",' >> $file_name
		echo '"new_ip": "'$new_ip_address'",' >> $file_name
		echo '"old_ip": "'$old_ip_address'",' >> $file_name
		echo '"new_mask": "'$new_subnet_mask'",' >> $file_name
		echo '"new_routers": "'$new_routers'"' >> $file_name
		echo '}' >> $file_name

		#update ip with network.restore.post
		#do not run update if db file is not exist
	        if [ -e "$safe_db_file" ]; then
			/usr/local/nsc/hooks/network.restore.post --mode=boot | logger -t 'net.restore.post(dhclient)'
		fi
	fi
	if [ ! -z "$new_ip6_address" -a "$new_ip6_address" != "" ]; then
                ip_type=6
                file_name=/tmp/dhcp.$interface.$ip_type
                #delete the old file first, create new one json format
                rm -f $file_name
                echo "{" >> $file_name
                echo '"reason": "'$reason'",' >> $file_name
                echo '"new_ip": "'$new_ip6_address'",' >> $file_name
                echo '"old_ip": "'$old_ip6_address'",' >> $file_name
                echo '"prefix": "'$new_ip6_prefixlen'",' >> $file_name
                echo '"new_routers": "'$new_dhcp6_gateway'"' >> $file_name
                echo '}' >> $file_name

		#update ip address with network.restore.post
		if [ -e "$safe_db_file" ]; then
			/usr/local/nsc/hooks/network.restore.post --mode=boot | logger -t 'net.restore.post(dhclient)'
		fi
	fi		  
}

sng-dhcp-handler_restore() {
	echo -n
}
