#!/bin/bash

execute()
{
    local outdir="output"
    local topdir="/provisioning"
    local tstamp="$(printf "%x" $(date +%s))"
    local name=$1

    set -exu

    rm -rf "/provisioning/$outdir"
    mkdir "/provisioning/$outdir"

    rsync -av "/provisioning/template/" "/provisioning/$outdir" || return 1
    rsync -av --exclude "template" --exclude "$outdir" --exclude ".git" "/provisioning" "/provisioning/$outdir/provisioning" || return 1

    pushd "/provisioning/$outdir" || return 1

    chown -R 499:499 .
    chown -R 0:0 /provisioning/template/etc/sudoers.d/


    tar --transform='s#^[.]/##' --show-stored-names -zcvf "$topdir/$name" "."

    popd
}

if [ "w$1" = "was-root" ]
then
    execute $2
else
    sudo bash "$0" "as-root" "$@"
fi

