#!/bin/bash

logg()
{
    /usr/bin/logger -t grub-product "$@"
}

GRUBCONF=/boot/grub/grub.conf

if [[ -e $GRUBCONF ]]
then
    product="$(/bin/awk -F'[="]+' '/^NAME=/ { print $2 }' /etc/os-release)"
    version="$(/bin/rpm -q --queryformat '%{VERSION}-%{RELEASE}' nsc)"

    if [[ ! "$product" ]] || [[ ! "$version" ]]
    then
        logg -p warn "Missing system information (product=$product, version=$version)"
        exit 1
    fi

    logg "Updating system information (product=$product, version=$version)"
    sed -ie "s#title ${product} [0-9.-]\+#title ${product} ${version}#" "$GRUBCONF"
else
    logg "No grub.conf found, not updating."
fi
