#!/bin/bash

# Copyright (C) 2015 Sangoma Technologies Inc.
# All Rights Reserved.
#
# Author:
# Leonardo Lang <lang@sangoma.com>
#
# Upgrade firewall configuration from NSC 2.1 to NSC 2.2

FW_OLD="/etc/firewall"
FW_DIR="/etc/firewall.d"
FW_BKP="${FW_OLD}.sngbkp"

FW_EXTIF="${FW_DIR}/firewall.extif"
FW_RULES="${FW_DIR}/firewall.rules"

upgrade_firewall ()
{
    mkdir "${FW_DIR}" || return 1

    awk '/^EXTIF=/ { print }' "${FW_OLD}" > "${FW_EXTIF}" || return 1
    awk 'BEGIN { p=0 } /^RULES=/ { p=1; print } /^"$/ { p=0; print } /^[ \t]+/ { if (p) print }' "${FW_OLD}" > "${FW_RULES}" || return 1

    mv -f "${FW_OLD}" "${FW_BKP}"
}

[ -f "${FW_OLD}" -a ! -d "${FW_DIR}" ] && upgrade_firewall
