#!/usr/bin/python2.7

import os
import sys
import json

import safe

class SafeApi():
    SAFE_JSON = '/usr/local/sng/cli/libs/product_release/safepy_def.json'

    def __init__(self):
        self._api = None

    def api(self):
        if self._api is None:
            self._api = safe.api('localhost', port=81,
                specfile=(self.SAFE_JSON if os.path.exists(self.SAFE_JSON) else None))

        return self._api

print 'Setting up pre-configuration for NSG...'

safeapi = SafeApi()

print '+ Querying IP addresses...'

syscfg = safeapi.api().system.configuration.retrieve()
ipscfg = syscfg['network']['ip']

local_ip = None

for ip, data in ipscfg.items():
    if data['interface'] == 'lo' and ip != 'ip_lo_100':
        local_ip = ip
        break
else:
    print 'ERROR: Unable to find "lo" IP address, cannot proceed.'
    sys.exit(1)

def send_config(num):
    print '+ Sending configuration request "{num!s}"...'.format(num=num)

    try:
        data = open('/usr/local/nsg/share/nsg-setup-{num!s}.json'.format(num=num)).read().replace('%LOCAL_IP_NAME%', local_ip)
        r = safeapi.api().system.configuration.update(dict(data=data, mode='update'))
        print '++ Result: ' + json.dumps(r)
    except Exception as e:
        try:
            print '++ ERROR: ' + json.dumps(e.args[0]['error'])
        except:
            etype, edata = type(e).__name__, str(e)
            print '++ ERROR: ' + etype + ': ' + edata + ''
        sys.exit(1)

for num in [ 1, 2, 3 ]:
    send_config(num)

print 'All done!'
sys.exit(0)
