#!/bin/sh

# Copyright: Sangoma Technologies Corp. 2016
#
# Author: Leonardo Lang
# Description:
#
# Runs command with timeout, sends SIGKILL to process if timeout is reached.

if [ "$#" -le 1 ]
then
    echo "usage: $0 <timeout> [command]"
    exit 1
fi

timeout=$1
shift

"$@" &
procpid=$!

exec 0>/dev/null
exec 1>/dev/null
exec 2>/dev/null

terminate() {
    timerpid=0
    kill -KILL $procpid
}
trap terminate TERM

timer() {
    sleep $timeout
    kill -TERM $$
}
timer &
timerpid=$!

wait $procpid
rc=$?

[ "$timerpid" != "0" ] && \
    kill -TERM $timerpid

exit "$rc"
