#!/bin/env bash

SNG_CONFIG="/usr/local/sng/conf"

NSC_PROD_NAME="nsc"
NSCG_PROD_NAME="nscg"

update_link()
{
    local prodname="$1"
    local linkname="$2"

    local fullname="$prodname-prod-def.xml"
    local currname=`readlink "$linkname"`

    [ "w$currname" = "w$fullname" ] && return 1

    ln -sf "$fullname" "$linkname"
    return 0
}

update_links()
{
    local prodname="$1"
    local ret=0

    update_link "$prodname" vega_session_controller.xml      || ret=1
    update_link "$prodname" netborder_session_controller.xml || ret=1

    return $ret
}

update_product()
{
    /usr/local/sng/scripts/update-product.sh 
}

if grep -q '0x1923' /sys/bus/pci/devices/*/vendor 2>/dev/null
then
    (cd ${SNG_CONFIG} && update_links "${NSCG_PROD_NAME}") && update_product
else
    (cd ${SNG_CONFIG} && update_links "${NSC_PROD_NAME}") && update_product
fi
