<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
 */
/*
 * FS Sangoma SNMP module class
 */

require_once ('application/helpers/safe_helper.php');
safe_require_class('safe_service_class');

class Fs_snmp_module_class extends Fs_module_class  {


    public function __construct($fs_app)
    {
        parent::__construct($fs_app, "snmp");
    }
    /**
      * @brief Is module enabled
      *
      * @param[in out] $mod_name
      *
      * @return
     */

    public function is_enabled($mod_name = "")
    {
          $snmp_module = $this->node()->software()->application()->find_module_by_name('snmpd');
          $snmp_cfg = $snmp_module->config();

          if($snmp_cfg->is_agentx() && $snmp_cfg->is_sysstat()){
              return true;
          }
          return false;
    }

    /**
     * Returns whether the module is a critical module
     * @return boolean
     */
    public function is_critical($mod_name="")
    {
        return false;
    }
    public function support_reload(&$need_reload = NULL)
    {
        return true;
    }
    public function reload($mod_name="")
    {
        // Reload module
        if (Safe_service_class::STATUS_RUNNING == $this->fs_app()->status()){
            if($this->is_enabled()){
                $rc = $this->eslapi_execute("reload mod_".$this->name(), '', $output);
            }else{
                $rc = $this->eslapi_execute("unload mod_".$this->name(), '', $output);
            }
            return true;
        }
        return false;
    }
}

/* End of file fs_snmp_module_class.php */
