<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * FS Directory Config wrapper page
 * @author Kent Hong <khong@sangoma.com>
 *         
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
safe_require_controller('sng','config_manager');
class Fs_sngms_config extends Sng_config_manager
{
    public function __construct()
    {
        parent::__construct();
        $this->aggregate_object_view['_global']['modify'] = 'safe_tabs';
        $sngms = $this->_the_app->find_module_by_name('sngms');
        
        $cfg = $sngms->config();
        // Check if HW transcoding is enabled
        if(!$cfg->is_enabled()){
            // No, then don't display childs (ie. modules)
            $this->hide_aggregate_object_list['module'] = true;
            $this->hide_aggregate_object_list['device'] = true;
            // Do not display module actions
            $this->display_module_action = false;
        }
        $modules = $sngms->api_retrieve_module();
        if(count($modules) <= 1){
            $this->hide_aggregate_object_list['device'] = true;
        }
        $this->allow_back = true;
    }
    public function index($module_name = 'sngms', $data_name = false, $offset = null)
    {
        return $this->modify($module_name, $data_name);
    }
    public function get_update_log()
    {
        $module = $this->_the_app->find_module_by_name('sngms');
        $rs = $module->get_fwupdate_log($data_name, $param, $output);
        $rs_data['status'] = true;
        $rs_data['data'] = $output;
        echo json_encode($rs_data);
    }
    public function modify($module_name, $data_name = null){
        // set force-software flag back to false
        if($data_name == 'force-software'){
            $core_module = $this->_the_app->find_module_by_name('core');
            $core_data = $core_module->config()->get_data_values(false);

            if(intval($core_data['force-software']) == 1){
                $core_data['force-software'] = '0';
                $core_module->config()->set_data_values($core_data);
                $core_module->config()->save();
            }
        }
        return parent::modify('sngms');
    }
}
