<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 *
 * @author Michel Buczynski <mbucyznski@sangoma.com>
 *         
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
define('SAFE_CMD_SUDO', "/usr/bin/sudo");
define('SAFE_CMD_RM', '/bin/rm');
define('SAFE_CMD_CAT', '/bin/cat');
define('SAFE_CMD_MOVE', '/bin/mv');
define('SAFE_CMD_COPY', '/bin/cp');
define('SAFE_CMD_TOUCH', '/bin/touch');
define('SAFE_CMD_CHOWN', '/bin/chown');
define('SAFE_CMD_CHMOD', '/bin/chmod');
define('SAFE_CMD_LS', '/bin/ls');
define('SAFE_CMD_MD5', '/usr/bin/md5sum');
define('SAFE_CMD_FILE', '/usr/bin/file');
define('SAFE_CMD_HEAD', '/usr/bin/head');
define('SAFE_CMD_REPLACE', '/usr/sbin/app-rename');
define('SAFE_CMD_STDERR_REDIRECT', ' 2>&1 ');
define('SAFE_CMD_SCRIPTS', '/usr/local/sng/scripts');
define('SAFE_CMD_TIMEOUT', 'sng-timeout-exec.sh');
define('SAFE_FILE_LOCK', '/var/webconfig/tmp/safe.lock');

define('ADD_NONE_ALWAYS', 'always');
define('ADD_NONE_NEVER', 'never');
define('ADD_NONE_IF_EMPTY', 'empty');

define('SAFE_IPV4', 4);
define('SAFE_IPV6', 6);

define('SAFE_LOG_DEBUG', 'DEBUG');
define('SAFE_LOG_INFO', 'INFO');
define('SAFE_LOG_ERROR', 'ERROR');

/**
 * Authenticate, if not logged it's redirect at a login screen;
 *
 * @return boolean (Should never return false, page are recreated or
 *                 redirected.)
 */
function safe_authenticate($redirect=true)
{
    if (isset($GLOBALS['SAFE_WC_HELPER'])) {
        return SAFE_WC_AUTHENTICATE($redirect);
    }
    return false;
}
/**
 * Increments an IP Address. Returns true if it can increment successfully. Returns false if IP address beyond Class A/B/C Range.
 * @param string  $ip_address
 * @return boolean
 */
function increment_ip_old(&$ip_address)
{
    // Increment base IP
    $ip = explode('.', $ip_address);
    if (4 == count($ip)) {
        $ip[3] = $ip[3] + 1;
        // Checks the forth octet for not greater than 255
        if ($ip[3] >= 255) {
            $ip[3] = 1;
            $ip[2] = $ip[2] + 1;
        }
        //Checks the third octed for greater than 255
        if ($ip[2] > 255) {
            $ip[2] = 1;
            $ip[1] = $ip[1] + 1;
        }
        //Checks the second octet for greater than 255
        if ($ip[1] > 255) {
            $ip[1] = 1;
            $ip[0] = $ip[0] + 1;
        }
        //Checks the first octet for a valid first octet (1-223)
        if ($ip[0] > 223) {
            //Not classful range return error
            //Not sure how to handle the error at this point
            return false;
        }
        $ip_address = implode('.', $ip);
    }
    return true;
}
function increment_ip(&$ip, $increment = 1)
{
    $addr = @inet_pton($ip);
    if($addr === false){
        return false;
    }
    for ($i = strlen($addr) - 1; $increment > 0 && $i >= 0; --$i )
    {
        $val = ord($addr[$i]) + $increment;
        $increment = $val / 256;
        $addr[$i] = chr($val % 256);
    }
    $ip = inet_ntop($addr);
    return true;
}
function safe_redirect($url)
{
    echo '
    <script type="text/javascript">
window.location = "' . $url . '";
    </script>';
    exit();
}
/**
 * Return the default web header
 *
 * @param $title      string
 * @param $summary    string
 * @param $large_icon string
 * @param $small_icon string
 * @return string     
 */
function safe_webheader($title = 'SAFe -', $summary = '', $large_icon = '', $small_icon = '', $extra_text = '')
{
    // TODO: handle title.
    if (isset($GLOBALS['SAFE_WC_HELPER'])) {
        $html = SAFE_WC_HEADER($title);
        /*
        $html.= <<<EOD
<script type="text/javascript">
    $('#clearos_left_menu').accordion({
      autoHeight: false, active: 0 });
    </script>
EOD;
         */
        $html.= SAFE_WC_DIALOGINTRO($title, $summary, $large_icon, $small_icon, $extra_text);
        return $html;
    } else {
        return <<<EOD
    <html>
    <head>
    </head>
    <body>
EOD;
        
    }
}
/**
 * Create a hyperlink
 */
function safe_hyperlink($url, $value, $download = false)
{
    if (isset($GLOBALS['SAFE_WC_HELPER'])) {
        if ($download == true) return "<a style='text-decoration:underline;' href=\"" . $url . "\" target=\"_blank\">" . $value . "</a>";
        else return "<a style='text-decoration:underline;' href=\"" . $url . "\">" . $value . "</a>";
    } else {
        if ($download == true) echo "<a style='text-decoration:underline;' href=\"" . $url . "\" target=\"_blank\">" . $value . "</a>";
        else echo "<a style='text-decoration:underline;' href=\"" . $url . "\">" . $value . "</a>";
    }
}
/**
 * Return the default web footer.
 *
 * @return string
 */
function safe_webfooter()
{
    if (isset($GLOBALS['SAFE_WC_HELPER'])) {
        return SAFE_WC_FOOTER();
    } else {
        return <<<EOD
    </body>
    </html>

EOD;
        
    }
}
/**
 * Return a opening table with a title
 *
 * here style defined by clearos 5.x webconfig
 *         .mytableheader
 *         .mytablesubheader
 *         .rowenabled
 *         .rowhoverhighlight
 *         .rowenabledalt
 *         .rowdisabled
 *         .rowdisabledalt
 *         .mytablealt
 *         .mytablelegend
 *         .mytablecheckboxes
 *
 * @param string $title      
 * @param string $title      
 * @param string $width      
 * @param string $id         
 * @param string $extra_class
 * @param string $extra_style
 * @param string $padding    
 * @return string
 *                
 */
function safe_webtabletitleopen($title = '', $width = '100%', $id = '', $extra_class = '', $extra_style = '', $padding = '3px')
{
    if (isset($GLOBALS['SAFE_WC_HELPER'])) {
        return SAFE_WC_TABLEOPEN($title, $width, $id, $extra_class, $extra_style, $padding);
    } else {
        return <<<EOD
    <div width='$width'>$title</div>
    <table width='$width' id='$id'>
EOD;
        
    }
}
/**
 * remove table title and corner style //table_open.inc
 *
 * @param string $html
 * @return string
 *
 */
function safe_webtabletitleopen_json($html)
{
    $html = preg_replace('/(<div[^>]+widget-content-header[^>]+>.+?)+(<\/div>)/i', '', $html);
    $html = preg_replace('/ui-corner-top/', '', $html);//remove corner top
    $html = preg_replace('/ui-corner-bottom/', '', $html);//remove corner bottom
    $html = preg_replace('/ui-state-active/', '', $html);//remove border
    return $html;
}
/**
 * Return closing tag for safe_webtabletitleopen()
 *
 * @return string
 */
function safe_webtableclose()
{
    if (isset($GLOBALS['SAFE_WC_HELPER'])) {
        return SAFE_WC_TABLECLOSE();
    } else {
        return <<<EOD
  </table>
EOD;
        
    }
}
/**
 * Creates a form with a single submit and a message to put before the button.
 * For use when a simple button is required
 *
 * @param $message      string
 *                             The message to display before the submit button
 * @param $action       string
 *                             Page for form to redirect to
 * @param $button_label string
 *                             html value parameter for the submit button
 * @param $button_value string
 *                             html name parameter for the submit button
 *                             
 */
function safe_form_with_submit_button($message, $action, $button_label, $button_value = NULL, $method = 'post', $style = NULL, $hidden_fields = array())
{
    if (isset($button_value)) $button_name = ' name="' . $button_value . '" ';
    else $button_name = '';
    if (isset($style)) $style = ' style="' . $style . '" ';
    else $style = "";
    $extra_fields = "";
    foreach ($hidden_fields as $k => $v) {
        $extra_fields.= '<input type="hidden" name="' . $k . '" value="' . $v . '"/>';
    }
    return '
    <form action="' . $action . '" method="' . $method . '" enctype="multipart/form-data">' . $message . $extra_fields . '<input ' . $button_name . $style . ' value="' . $button_label . '" type="submit" class="ui-state-default ui-corner-all">
    </form>';
}
function safe_form_action_button($message, $action, $button_label, $button_value = null, $method = 'post', $style = null, $hidden_fields = array())
{
    $tmp_button  = safe_form_with_submit_button($message, $action, $button_label, $button_value, $method, $style, $hidden_fields);
    $tmp_button = str_replace('type="submit"','type="button" onclick="safe_handle_create_button(this);"', $tmp_button);
    $tmp_button = '<div style="float:left">'.$tmp_button.'</div>';
    return $tmp_button;
}
function safe_form_global_action($message = '', $buttons ='')
{
    return '<div class="safe_notif_warn">' . $message . ' <span style=" margin-left: 5px; margin-right: 5px;"> : </span> </div>' . $buttons;
}
function safe_form_with_submit_button_confirm($message, $action, $button_label, $button_value = NULL, $method = 'post', $style = NULL, $hidden_fields = array())
{
    if (isset($button_value)) $button_name = ' name="' . $button_value . '" ';
    else $button_name = '';
    if (isset($style)) $style = ' style="' . $style . '" ';
    else $style = "";
    $extra_fields = "";
    foreach ($hidden_fields as $k => $v) {
        $extra_fields.= '<input type="hidden" name="' . $k . '" value="' . $v . '"/>';
    }
    return '
        <form action="' . $action . '" method="'
        . $method . '" enctype="multipart/form-data">'
        . $message . $extra_fields . '<input '
        . $button_name . $style . ' value="' . $button_label
        . '" type="button" onclick="safe_handle_confirm_button(this);" class="ui-state-default ui-corner-all">
    </form>';
}
function safe_button_click($name, $value, $url, $id = '', $attributes = null)
{
    $html = '
    <input name="' . $name . '" value="' . $value . '" type="button" class="ui-state-default ui-corner-all" ';
    foreach ($attributes as $attr => $attr_value) {
        $html.= ' ' . $attr . '="' . $attr_value . '"';
    }
    $html.= ' onclick="window.location.href=\'' . $url . '\'" />';
    return $html;
}
/**
 * Return a warning dialog box
 *
 * @param $message array|string
 *                               the message or array of messages
 * @return string; 
 */
function safe_webdialogwarning($message)
{
    if (empty($message)) return '';
    if (is_array($message) && count($message) > 1) {
        $multiple = "";
        if (isset($message['buttons']) && is_array($message['buttons'])) {
            $buttons = $message['buttons'];
        }
        foreach ($message as $error) {
            if (!empty($error) && !is_array($error)) {
                if (isset($error['buttons']) && is_array($error['buttons'])) {
                    $buttons = $error['buttons'];
                }
                else {
                    if ($multiple) $multiple.= "<br/>\n";
                    $multiple.= "$error\n";
                }
            }
        }
        if (isset($GLOBALS['SAFE_WC_HELPER'])) {
            return SAFE_WC_DIALOGWARNING($multiple, $buttons);
        } else {
            return <<<EOD
      <table><tr><td>
      $multiple
      </tr></td></table>
EOD;
            
        }
    } else {
        if (is_array($message)) $message = array_pop($message);
        if (isset($GLOBALS['SAFE_WC_HELPER'])) {
            return SAFE_WC_DIALOGWARNING($message);
        } else {
            return <<<EOD
      <table><tr><td>
      $message
      </tr></td></table>
EOD;
            
        }
    }
}
/**
 * Return a info dialog box
 *
 * @param $message array|string
 *                               the message or array of messages
 * @return string; 
 */
function safe_webdialoginfo($message)
{
    if (empty($message)) return '';
    if (is_array($message) && count($message) > 1) {
        $multiple = "";
        if (isset($message['buttons']) && is_array($message['buttons'])) {
            $buttons = $message['buttons'];
        }
        foreach ($message as $error) {
            if (!empty($error) && !is_array($error)) {
                    if ($multiple) $multiple.= "<br/>\n";
                    $multiple.= "$error\n";
            }
        }
        if (isset($GLOBALS['SAFE_WC_HELPER'])) {
            return SAFE_WC_DIALOGINFO($multiple, $buttons);
        } else {
            return <<<EOD
      <table><tr><td>
      $multiple
      </tr></td></table>
EOD;
            
        }
    } else {
        if (is_array($message)) $message = $message[0];
        if (isset($GLOBALS['SAFE_WC_HELPER'])) {
            return SAFE_WC_DIALOGINFO($message);
        } else {
            return <<<EOD
  <table><tr><td>
  $message
  </tr></td></table>
EOD;
            
        }
    }
}
/**
 * Return a info dialog box
 *
 * @param $message array|string
 *                               the message or array of messages
 * @return string; 
 */
function safe_webdialog($message, $icon, $class = '')
{
    if (empty($message)) return '';
    if (is_array($message) && count($message) > 1) {
        $multiple = "";
        foreach ($message as $error) {
            if (!empty($error)) {
                if ($multiple) $multiple.= "<br/>\n";
                $multiple.= "$error\n";
            }
        }
        if (isset($GLOBALS['SAFE_WC_HELPER'])) {
            return SAFE_WC_DIALOG($multiple, $icon, $class);
        } else {
            return <<<EOD
      <table><tr><td>
      $multiple
      </tr></td></table>
EOD;
            
        }
    } else {
        if (is_array($message)) $message = $message[0];
        if (isset($GLOBALS['SAFE_WC_HELPER'])) {
            return SAFE_WC_DIALOG($message, $icon, $class);
        } else {
            return <<<EOD
  <table><tr><td>
  $message
  </tr></td></table>
EOD;
            
        }
    }
}
/**
 * create a file cvs file
 *
 * @param $filename string
 * @param $data     array
 * @param $setting  array (csv format setting)
 * @return boolean
 */
function safe_csv_download($obj_name = '', $data = null)
{
    $tmp_path = '/tmp/download-files/';
    if(false == safe_verify_tmp($tmp_path)){
        header("HTTP/1.0 403 Forbidden");
        exit();
    }else{
        $name = php_uname('n') . '-' . $obj_name . '-' . date('Y-m-d-H-i-s') . '.csv';
        $fp = fopen($tmp_path.$name, 'w');
        foreach ($data as $obj_item){
            fputcsv($fp, $obj_item);
        }
        fclose($fp);
        safe_download($tmp_path.$name,null,$name,'text/csv',true);
        $rs = unlink($tmp_path.$name);
    }
}

function safe_mime_content_type($filename) {
    $realpath = realpath($filename);
    $rs = false;
    if ($realpath
            && function_exists('finfo_file')
            && function_exists('finfo_open')
            && defined('FILEINFO_MIME_TYPE')
    ){
        // Use the Fileinfo PECL extension (PHP 5.3+)
        $rs =  finfo_file( finfo_open( FILEINFO_MIME_TYPE ), $realpath );
    }
    if (!$rs && function_exists( 'mime_content_type' ) ) {
        // Deprecated in PHP 5.3
        $rs = mime_content_type( $realpath );
    }
    if (!$rs){
        // Try to determine if the filename includes a file extension.
        // We need it in order to set the MIME type
        if (false === strpos($filename, '.')) {
            $rs = 'application/octet-stream';
        } else {
            // Grab the file extension
            $extension = end(explode('.', $filename));
            // Load the mime types
            if (defined('ENVIRONMENT') AND is_file(APPPATH . 'config/' . ENVIRONMENT . '/mimes.php')) {
                include (APPPATH . 'config/' . ENVIRONMENT . '/mimes.php');
            } elseif (is_file(APPPATH . 'config/mimes.php')) {
                include (APPPATH . 'config/mimes.php');
            }
            // Set a default mime if we can't find it
            if (isset($mimes[$extension])) {
                $rs = (is_array($mimes[$extension])) ? $mimes[$extension][0] : $mimes[$extension];
            }
        }
    }
    return $rs;
}
/**
 * Download a file
 *
 * @param $filename string    
 * @param $data     string    
 * @param $accept   string    
 * @param $maxsize  int|string
 * @return boolean  
 */
function safe_download($filename = '', $buffer = NULL, $user_filename = NULL, $mime = NULL, $delete = false)
{
    // TODO: webconfig (the apache server is running under UID 101 so php also
    // $ph = popen("/usr/bin/sudo /bin/cat " . escapeshellarg($filename), "r");
    // if (!$ph)
    // return false;
    // $content = "";
    // while ($chunk = fread($ph, 4096))
    // $content .= $chunk;
    // pclose($ph);
    // or exec("sudo cat ".escapeshellarg($filename),$data); // add \n in each
    // string of the $data array
    // the utilisation of the CodeIgniter output class
    // $this->output->set_header('Content-type: application/json');
    // $this->output->set_output(json_encode($data));
    //
    // Check if file or buffer
    $content_length = 0;
    if (!isset($buffer)) {
        if ($filename == '' or !(file_exists($filename)) or !(is_readable($filename))) {
            header('HTTP/1.0 404 Not Found');
            exit();
        }        
        // Get file content
        // $data = file_get_contents($filename);
        $content_length = filesize($filename);
    } else {
        $data = $buffer;
        $content_length = strlen($data);
    }
    // Check for mime
    if (!isset($mime)) {
        if (!isset($buffer)) {
            $mime = safe_mime_content_type($filename);
        }
    }
    if (!isset($mime)) $mime = 'text/plain';
    // Check exposed file name
    if (!isset($user_filename)) $user_filename = $filename;
    // Generate the server headers
    if (strpos($_SERVER['HTTP_USER_AGENT'], "MSIE") !== FALSE) {
        header('Content-Type: ' . $mime);
        header('Content-Disposition: attachment; filename="' . $user_filename . '"');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header("Content-Transfer-Encoding: binary");
        header('Pragma: public');
        header("Content-Length: " . $content_length);
    } else {
        header('Content-Type: ' . $mime);
        header('Content-Disposition: attachment; filename="' . $user_filename . '"');
        header("Content-Transfer-Encoding: binary");
        header('Expires: 0');
        header('Pragma: no-cache');
        header("Content-Length: " . $content_length);
    }
    if($delete === true){
        readfile($filename);
        @unlink($filename);
        exit();
    }else{
        if(!isset($buffer)){
            readfile($filename);
            exit();
        }
        else
            exit($data);
    }
}
/**
 * Make a upload (AJAX style).
 * Return nothing.
 *
 * @param $filename    string 
 *                             The target files name and path.
 * @param $data        string 
 *                             data of the uploaded file.
 * @param $make_backup boolean
 *                             If we make backup or not.
 * @param $sudo        boolean
 *                             do it give the root privelege or not
 *                             
 */
function safe_upload_ajax($filename, $data, $make_backup = true, $sudo = true)
{
    // file_put_contents may also be use
    if (safe_write_file($filename, $data, $make_backup, $sudo)) exit();
    else {
        header("HTTP/1.0 403 Forbidden");
        safe_log(SAFE_LOG_ERROR, "ERROR! Safe_upload:" . $filename . " is not writable!");
        exit();
    }
}
/**
 * Write a file.
 *
 *
 * @param $filename    string 
 *                              The target files name and path.
 * @param $data        string 
 *                              data of the uploaded file.
 * @param $make_backup boolean
 *                              If we make backup or not.
 * @param $sudo        boolean
 *                              Give the root privilege or not
 * @return boolean      True if the file was written.
 */
function safe_write_file($pathfilename, $data, $make_backup = true, $sudo = true)
{
    // file_put_contents may also be use
    $uniqid = uniqid();
    // writable
    if (is_writable($pathfilename)) {
        if (is_writable($pathfilename) && $make_backup && file_exists($pathfilename)) {
            @copy($pathfilename, $pathfilename . ".bak");
            // error_Log ( "Safe_write_file:" . $pathfilename . "." . $uniqid .
            // " backup file was created!" );
            
        }
        // this is codeigniter file helper
        if (write_file($pathfilename, $data, 'w')) {
            //error_log ( "Safe_write_file:" . $pathfilename . " was written!" );
            return true;
        }
        // not writeable and sudo allowed
        
    } elseif ($sudo) {
        $tmp_path = safe_verify_tmp();
        $tmp_pathfilename = $tmp_path . '/' . pathinfo($pathfilename, PATHINFO_FILENAME) . '.' . uniqid();
        $done = (write_file($tmp_pathfilename, $data, 'w') && safe_sudo_copy($tmp_pathfilename, $pathfilename));
        @unlink($tmp_pathfilename);
        if ($done) {
            //error_log ( "Safe_write_file:" . $pathfilename . " was written!" );
            return true;
        }
    }
    //error_log ( "ERROR! Safe_write_file:" . $pathfilename . " was not written!" );
    return false;
}
/**
 * Make a copy of file in root privilege.
 * Normally to copy a temp file in root protected folder.
 *
 * @param $src_pathfilename string 
 *                                   Ther source path and filename
 * @param $dst_pathfilename string 
 *                                   The destination
 * @param $make_backup      boolean
 *                                   To make or not a destination backup
 * @return boolean           True if the file was copied
 *                           
 */
function safe_sudo_copy($src_pathfilename, $dst_pathfilename, $make_backup = true)
{
    // for /bin/cp here some important option for us
    // -f, --force
    // if an existing destination file cannot be opened, remove it and try again
    // -T, --no-target-directory
    // treat DEST as a normal file
    // -u, --update
    // copy only when the SOURCE file is newer than the destination
    // file or when the destination file is missing
    // --backup[=CONTROL]
    // make a backup of each existing destination file
    // The backup suffix is '~', unless set with --suffix or
    // SIMPLE_BACKUP_SUFFIX.
    // The version control method may be selected via the --backup option or
    // through the VERSION_CONTROL environment variable. Here are the values:
    // none, off : never make backups (even if --backup is given)
    // numbered, t : make numbered backups
    // existing, nil : numbered if numbered backups exist, simple otherwise
    // simple, never : always make simple backups
    // As a special case, cp makes a backup of SOURCE when the force and backup
    // options are given and SOURCE and DEST are the same name for an existing,
    // regular file.
    $uniqid = uniqid();
    // $r=0;
    if ($make_backup && file_exists($dst_pathfilename)) {
        $out = safe_sudo_exec(SAFE_CMD_COPY, '-f', $dst_pathfilename . ' ' . $dst_pathfilename . '.bak', $r);
        if ($r != 0) safe_log(SAFE_LOG_ERROR, "Safe_sudo_copy: backup $dst_pathfilename : $out :FAIL: $r ");
    }
    // even if the backup fail we will try the normal copy.
    $r = 0;
    $out = safe_sudo_exec(SAFE_CMD_COPY, '-f', array(
        $src_pathfilename,
        $dst_pathfilename
    ) , $r);
    if ($r != 0) {
        safe_log(SAFE_LOG_ERROR, "Safe_sudo_copy: copy $src_pathfilename to $dst_pathfilename : $out :FAIL: $r ");
        return false;
    }
    return true;
}
/**
 * Excute in a secure way a command with root privilege.
 *
 * @param $command      string      
 *                                    command to be execute
 * @param $line_options string      
 *                                    The line options of the command
 * @param $arguments    string|array
 *                                    Arguments, that will be secured
 * @param $return_var   int         
 *                                    return status of the executed command
 * @return array         Filled line by line with the output from the command.
 */
function safe_sudo_exec($command, $line_options = '', $arguments = '', &$return_var = null, $escapeshell = true, $timeout = null)
{
    return safe_exec(SAFE_CMD_SUDO . ' ' . $command, $line_options, $arguments, $return_var, $escapeshell, $timeout);
}
function safe_exec($command, $line_options = '', $arguments = '', &$return_var = null, $escapeshell = true, $timeout = null)
{
    list($return_var, $output, $empty_output) = safe_pipe_exec($command, $line_options, $arguments, $escapeshell, '', $timeout, true);
    $lines = preg_split("(/\r\n|\r|\n)", $output);
    $result = array();
    foreach ($lines as $line) {
        $result[] = rtrim($line);
    }
    return $result;
}

function safe_sudo_pipe_exec($command, $line_options = '', $arguments = '', $escapeshell = true, $input_data = '', $timeout = null, $redirect = false)
{
    return safe_pipe_exec(SAFE_CMD_SUDO . ' ' . $command, $line_options, $arguments, $escapeshell, $input_data, $timeout, $redirect);
}

function safe_pipe_exec($command, $line_options = '', $arguments = '', $escapeshell = true, $input_data = '', $timeout = null, $redirect = false)
{
    $command = $command . ' ' . $line_options . ' ';
    if ($arguments != '') {
        if (is_string($arguments)) $arguments = preg_split("/[\s,]+/", $arguments);
        array_map("escapeshellarg", $arguments);
        $command.= implode(' ', $arguments) . ' ';
    }
    if ($escapeshell) $command = escapeshellcmd($command);

    if ($redirect) $command = $command . SAFE_CMD_STDERR_REDIRECT;
    if ($timeout) $command = SAFE_CMD_SCRIPTS . '/' . SAFE_CMD_TIMEOUT . ' ' . $timeout . ' ' . $command;

    $pipes = NULL;
    $proc = proc_open($command, array(array('pipe', 'r'), array('pipe', 'w'), array('pipe', 'w')), $pipes);

    fwrite($pipes[0], $input_data);
    fclose($pipes[0]);

    $stdout = stream_get_contents($pipes[1]);
    fclose($pipes[1]);
    $stderr = stream_get_contents($pipes[2]);
    fclose($pipes[2]);

    $return_code = proc_close($proc);

    //safe_log(SAFE_LOG_INFO, "Safe_exec: " . $command ." -- rc=".$return_code);
    return array($return_code, $stdout, $stderr);
}

/**
 * Verify and fix a specify tmp path or write folder path
 *
 * @param $path  string
 * @return string false fixed path without trailling / or false
 */
function safe_verify_tmp($path = '/tmp/SAFeUPLOADs')
{
    $tmp_path = realpath($path);
    if($tmp_path !== false){
        $path = $tmp_path;
    }
    $path = preg_replace('#/+$#', '', $path); // remove trailing /
    $path = preg_replace('#/+#', '/', $path); // replace non-single /
    if (!is_dir($path)) {
        if (file_exists($path)) @unlink($path);
        @mkdir($path, 0700, true);
    } else {
        if (!is_writable($path)) {
            @chmod($path, 0700);
        }
    }
    // Check
    if (is_dir($path) && is_writable($path)) return $path;
    else {
        // maybe put a default path!
        safe_log(SAFE_LOG_ERROR, "ERROR: Safe_verify_tmp('" . $path . "')");
        return false;
    }
}
function safe_var_dump($v)
{
    $trace = debug_backtrace();
?>
<br />
<pre
  style="display: block; text-align: left; color: black; background-color: yellow; font-size: small;">

<?php
    echo gettype($v) . ' called from: ';
    if (!empty($trace[1]['file'])) echo $trace[1]['file'] . '[' . $trace[1]['line'] . '] by function ' . $trace[1]['function'] . "\n";
    else echo "??? \n";
    print_r($v);
?>
</pre>
<br />
<?php
}
/**
 * Echo the debug backtrace
 */
function safe_debug_info($display=true, $bt = null)
{
    if(null == $bt) {
        $bt = debug_backtrace();
    }
    if($display){
        echo '<pre style="display: block; text-align: left; color: black; background-color: #D5D5D5; font-size: medium;">';
    }
    foreach ($bt as $k => $v) {
        if ($k) {
            $l = safe_debug_info_line($v, $k);
            if($display){
                echo htmlentities($l);
            }else{
                safe_log(SAFE_LOG_DEBUG, $l);
            }
        }
    }
    if($display){
        echo "</pre>";
    }
}
/**
 * Create a string from a backtrace line.
 * @param array  $v the backtrace line.
 * @param int    $k the backtrace index.
 * @return string
 */
function safe_debug_info_line($v, $k = 1)
{
    $backtracel = "";
    if ($v['function'] == "include" || $v['function'] == "include_once" || $v['function'] == "require_once" || $v['function'] == "require") {
        $backtracel.= "#" . ($k - 1) . " " . $v['function'] . "(" . $v['args'][0] . ") called at [" . $v['file'] . ":" . $v['line'] . "]\n";
    } else {
        $backtracel.= "#" . ($k - 1) . " " . $v['function'] . "() called at [" . ((!empty($v['file'])) ? $v['file'] : '') . ":";
        $backtracel.= ((!empty($v['line'])) ? $v['line'] : '') . "]\n";
    }
    return $backtracel;
}
/**
 * Add error with safe_errors_lib
 * @param string  $error            
 * @param boolean $apache_log       
 * @param boolean $include_backtrace
 * @param boolean $terminated       
 */
function safe_add_error($error, $apache_log = false, $include_backtrace = true, $terminated = false)
{
    $CI = & get_instance();
    $CI->safe_errors_lib->add_error($error, $apache_log, $include_backtrace, $terminated);
}
function safe_full_class_name($class)
{
    if (file_exists(APPPATH . 'libraries/' . $class . '.php')) return ucfirst($class);
    else if (file_exists(APPPATH . 'libraries/safe_' . $class . '_class.php')) return ucfirst($class);
    else {
        //error_log ("SAFE: ERROR: Do not found $class class.");
        return False;
    }
}
function safe_full_class_pathfilename($class)
{
    if (file_exists(APPPATH . 'libraries/' . $class . '.php')) return APPPATH . 'libraries/' . $class . '.php';
    else if (file_exists(APPPATH . 'libraries/safe_' . $class . '_class.php')) return APPPATH . 'libraries/safe_' . $class . '_class.php';
    else {
        //error_log ("SAFE: ERROR: Do not found $class class.");
        return $class . '.php';
    }
}
function safe_module_full_class_pathfilename($module_name, $class_name)
{
    $path_to_class = BASEPATH . '../../' . strtoupper($module_name) . '_modules/application/libraries/';
    if (file_exists($path_to_class . strtolower($module_name) . '_' . $class_name . '_class.php')) {
        return $path_to_class . strtolower($module_name) . '_' . $class_name . '_class.php';
    }
    //error_log ("SAFE: ERROR: Do not found ".$class_name." class for module ".$module_name);
    return false;
}
function safe_module_require_class($module_name, $class_name)
{
    if (safe_module_full_class_pathfilename($module_name, $class_name) !== FALSE) {
        require_once safe_module_full_class_pathfilename($module_name, $class_name);
        return TRUE;
    }
    return FALSE;
}
function safe_module_class_name($module_name, $class_name)
{
    return ucfirst($module_name) . '_' . $class_name . '_class';
}
function safe_new_module_class($module_name, $class_name)
{
    if (FALSE !== safe_module_require_class($module_name, $class_name)) {
        $full_class_name = ucfirst($module_name) . '_' . $class_name . '_class';
        return new $full_class_name();
    }
    return null;
}
function safe_require_controller($module_name, $controller_name)
{
    $path_to_module = BASEPATH . '../../' . strtoupper($module_name) . '_modules/';
    $controller = strtolower($module_name) . '_' . $controller_name;
    $file = $path_to_module . $controller . '/controllers/'.$controller.'.php';
    if (file_exists($file)) {
        require_once($file);
        return true;
    }
    safe_log(SAFE_LOG_ERROR, "SAFE: ERROR: Do not found ".$controller_name." controller for module ".$module_name);
    return false;
}
/**
 * Do A require for a safe class libraries
 * @param string $class a safe class libraries short or full name
 */
function safe_require_class($class)
{
    // Look for the class first in the local application/libraries folder
    // then in the native system/libraries folder
    if (class_exists(safe_full_class_name($class)) === FALSE) require_once (safe_full_class_pathfilename($class));
}
function safe_require_module_controller($module_name)
{
    // look into SAFe/modules/xxx/controller/$module.php
    $file = BASEPATH . '../modules/' . $module_name . '/controllers/'.$module_name.'.php';
    if (file_exists($file)) {
        require_once($file);
        return true;
    }
    safe_log(SAFE_LOG_ERROR, "ERROR: Module controller not found: ".$file);
    return false;
}
/**
 * Load and invoke a safe class libraries
 * @param string $class
 * @return new    object of the safe class libraries or FALSE if error;
 */
function &safe_load_class($class)
{
    static $_classes = array();
    // Does the class exist? If so, we're done...
    if (isset($_classes[$class])) return $_classes[$class];
    $name = safe_full_class_name($class);
    // Did we find the class?
    if ($name === FALSE) exit('Unable to locate the specified class: ' . $class . '.php');
    // Is the request a class extension? If so we load it too
    safe_require_class($class);
    // Keep track of what we just loaded
    is_loaded($class);
    $_classes[$class] = new $name();
    return $_classes[$class];
}
function is_associative_array($arr)
{
    return (is_array($arr) && (!count($arr) || count(array_filter(array_keys($arr) , 'is_string')) == count($arr)));
}
function is_indexed_array($arr)
{
    return (is_array($arr) && (!count($arr) || count(array_filter(array_keys($arr) , 'is_int')) == count($arr)));
}
function &to_index_array(&$arr)
{
    if (!is_indexed_array($arr)) {
        $arr = array(
            $arr
        );
    }
    return $arr;
}
/**
 * Flush the ouput of code
 */
function safe_flush_ouput()
{
    $CI = & get_instance();
    $CI->output->_display();
    $CI->output->set_output('');
    flush();
}
function Safe_xml_to_array($xml)
{
    if (is_array($xml)) $xml = implode($xml);
    try{
        $xml_parser = new SimpleXMLElement(trim($xml));
        $xml_array = json_decode(json_encode($xml_parser) , true);
        unset($xml_parser);
        return $xml_array;
    }catch(Throwable $e){
        return null;
    }
}
function Safe_array_to_xml($root_element_name, $ar)
{
    $xml = new SimpleXMLElement("<?xml version=\"1.0\"?><{$root_element_name}></{$root_element_name}>");
    $f = create_function('$f,$c,$a', ' 
    foreach($a as $k=>$v) { 
      if(is_array($v)) { 
        if(is_associative_array($v)) {
          $ch=$c->addChild($k); 
          $f($f,$ch,$v); 
}else{
  foreach($v as $ak=>$av) {
    $ch=$c->addChild($k); 
    $f($f,$ch,$av); 
}
} 
} else { 
  $c->addChild($k,$v); 
} 
}');
    $f($f, $xml, $ar);
    return Safe_format_xml($xml->asXML());
}
class Array2XML {

    private static $xml = null;
    private static $encoding = 'UTF-8';

    /**
     * Initialize the root XML node [optional]
     * @param $version
     * @param $encoding
     * @param $format_output
     */
    public static function init($version = '1.0', $encoding = '', $format_output = true) {
        self::$xml = new DomDocument($version, $encoding);
        self::$xml->formatOutput = $format_output;
        self::$encoding = $encoding;
    }

    /**
     * Convert an Array to XML
     * @param string $node_name - name of the root node to be converted
     * @param array $arr - aray to be converterd
     * @return DomDocument
     */
    public static function &createXML($node_name, $arr=array()) {
        $xml = self::getXMLRoot();
        $xml->appendChild(self::convert($node_name, $arr));

        self::$xml = null;    // clear the xml node in the class for 2nd time use.
        return $xml;
    }

    /**
     * Convert an Array to XML
     * @param string $node_name - name of the root node to be converted
     * @param array $arr - aray to be converterd
     * @return DOMNode
     */
    private static function &convert($node_name, $arr=array()) {

        //print_arr($node_name);
        $xml = self::getXMLRoot();
        $node = $xml->createElement($node_name);

        if(is_array($arr)){
            // get the attributes first.;
            if(isset($arr['@attributes'])) {
                foreach($arr['@attributes'] as $key => $value) {
                    if(!self::isValidTagName($key)) {
                        throw new Exception('[Array2XML] Illegal character in attribute name. attribute: '.$key.' in node: '.$node_name);
                    }
                    $node->setAttribute($key, self::bool2str($value));
                }
                unset($arr['@attributes']); //remove the key from the array once done.
            }

            // check if it has a value stored in @value, if yes store the value and return
            // else check if its directly stored as string
            if(isset($arr['@value'])) {
                $node->appendChild($xml->createTextNode(self::bool2str($arr['@value'])));
                unset($arr['@value']);    //remove the key from the array once done.
                //return from recursion, as a note with value cannot have child nodes.
                return $node;
            } else if(isset($arr['@cdata'])) {
                $node->appendChild($xml->createCDATASection(self::bool2str($arr['@cdata'])));
                unset($arr['@cdata']);    //remove the key from the array once done.
                //return from recursion, as a note with cdata cannot have child nodes.
                return $node;
            }
        }

        //create subnodes using recursion
        if(is_array($arr)){
            // recurse to get the node for that key
            foreach($arr as $key=>$value){
                if(!self::isValidTagName($key)) {
                    throw new Exception('[Array2XML] Illegal character in tag name. tag: '.$key.' in node: '.$node_name);
                }
                if(is_array($value) && is_numeric(key($value))) {
                    // MORE THAN ONE NODE OF ITS KIND;
                    // if the new array is numeric index, means it is array of nodes of the same kind
                    // it should follow the parent key name
                    foreach($value as $k=>$v){
                        $node->appendChild(self::convert($key, $v));
                    }
                } else {
                    // ONLY ONE NODE OF ITS KIND
                    $node->appendChild(self::convert($key, $value));
                }
                unset($arr[$key]); //remove the key from the array once done.
            }
        }

        // after we are done with all the keys in the array (if it is one)
        // we check if it has any text value, if yes, append it.
        if(!is_array($arr)) {
            $node->appendChild($xml->createTextNode(self::bool2str($arr)));
        }

        return $node;
    }

    /*
     * Get the root XML node, if there isn't one, create it.
    */
    private static function getXMLRoot(){
        if(empty(self::$xml)) {
            self::init();
        }
        return self::$xml;
    }

    /*
     * Get string representation of boolean value
    */
    private static function bool2str($v){
        //convert boolean to text value.
        $v = $v === true ? 'true' : $v;
        $v = $v === false ? 'false' : $v;
        return $v;
    }

    /*
     * Check if the tag name or attribute name contains illegal characters
    * Ref: http://www.w3.org/TR/xml/#sec-common-syn
    */
    private static function isValidTagName($tag){
        $pattern = '/^[a-z_]+[a-z0-9\:\-\.\_]*[^:]*$/i';
        return preg_match($pattern, $tag, $matches) && $matches[0] == $tag;
    }
}
/**
 * @brief Format xml string given in arguement and returns the formatted
 *            string. Originally taken here:
 *            
 *            http://recursive-design.com/blog/2007/04/05/format-xml-with-php/
 *            
 * @param[in] $xml raw xml string to be formatted.
 *            
 * @return formatted string
 */
function Safe_format_xml($xml)
{
    // add marker linefeeds to aid the pretty-tokeniser (adds a linefeed between
    // all tag-end boundaries)
    $xml = preg_replace('/(>)(<)(\/*)/', "$1\n$2$3", $xml);
    // now indent the tags
    $token = strtok($xml, "\n");
    $result = ''; // holds formatted version as it is built
    $pad = 0; // initial indent
    $matches = array(); // returns from preg_matches()
    // scan each line and adjust indent based on opening/closing tags
    while ($token !== false):
        // test for the various tag states
        // 1. open and closing tags on same line - no change
        if (preg_match('/.+<\/\w[^>]*>$/', $token, $matches)):
            $indent = 0;
            // 2. closing tag - outdent now
            elseif (preg_match('/^<\/\w/', $token, $matches)):
                $pad-= 2;
                $indent = 0;
            // 3. opening tag - don't pad this one, only subsequent tags
            elseif (preg_match('/^<\w[^>]*[^\/]>.*$/', $token, $matches)):
                $indent = 2;
            // 4. no indentation needed
            else:
                $indent = 0;
            endif;
        // pad the line with the required number of leading spaces
        $line = str_pad($token, strlen($token) + $pad, ' ', STR_PAD_LEFT);
        $result.= $line . "\n"; // add to the cumulative result, with linefeed
        $token = strtok("\n"); // get the next token
        $pad+= $indent; // update the pad size for subsequent lines    endwhile;
        
    endwhile;
    return $result;
}
/**
* @brief Handle PHP error to display pretty error screen
*         
* @return
*/
$safe_error_buffer = array();
$safe_unhandled_exception = FALSE;
// Register error handler
set_error_handler('safe_error_handler');
register_shutdown_function('safe_shutdown_handler');
set_exception_handler('safe_exception_handler');
function safe_exception_handler($exception)
{
    global $safe_error_buffer;
    global $safe_unhandled_exception;
    $safe_unhandled_exception = TRUE;
    $safe_error_buffer[] = array(
        'severity' => 'UNHANDLED EXCEPTION',
        'message' => $exception->getMessage() ,
        'file' => $exception->getFile() ,
        'line' => $exception->getLine() ,
    );
}
function safe_error_level_to_string($level)
{
    $level_str = $level;
    switch ($level) {
    case E_ERROR:
    case E_CORE_ERROR:
    case E_COMPILE_ERROR:
        $level_str = "ERROR";
        break;

    case E_WARNING:
        $level_str = "WARNING";
        break;

    case E_NOTICE:
        $level_str = "NOTICE";
        break;

    case E_PARSE:
        $level_str = "PARSE ERROR";
        break;
    }
    return $level_str;
}
function safe_error_handler($errno, $errstr, $errfile, $errline, $errcontext = '')
{
    global $safe_error_buffer;
    switch ($errno) {
    case E_ERROR:
    case E_USER_ERROR:
    case E_CORE_ERROR:
    case E_COMPILE_ERROR:
    case E_WARNING:
    case E_PARSE:
        if(safe_development_mode()) {
            safe_log(SAFE_LOG_DEBUG, "$errno - $errstr - $errfile - $errline");
        }
        $safe_error_buffer[] = array(
            'severity' => safe_error_level_to_string($errno) ,
            'message' => $errstr,
            'file' => $errfile,
            'line' => $errline,
            'bt' => debug_backtrace(), 
            // Too much info - 'context' => $errcontext,
            
        );
        break;
    }
}
function safe_development_mode()
{
    if(file_exists("/usr/local/sng/conf/sng_dev_env")) {
        return true;
    }else{
        return false;
    }
}
function safe_shutdown_handler()
{
    global $safe_unhandled_exception;
    $error = error_get_last();
    if (NULL !== $error || $safe_unhandled_exception) {
        safe_error_handler($error['type'], $error['message'], $error['file'], $error['line']);
        global $safe_error_buffer;
        header("HTTP/1.1 500 Internal Server Error", TRUE, 500);
        echo "<link type='text/css' rel='stylesheet' href='/templates/sng/css/required.css'/>";
        echo '<br/>';
        echo '<br/>';
        echo '<br/>';
        echo '<div align="center" style="width:900px; margin:0 auto; text-align:center;">';
        echo '<table class="mytable">';
        echo '<tr>';
        echo '<td class="mytableheader " colspan="2" style="text-align:center";>';
        echo '<img src="/templates/sng/images/logo.png" style="float:none;"/>';
        echo '</td>';
        echo '</tr>';
        echo '<tr>';
        echo '<td class="mytableheader " colspan="2" style="text-align:center; color:red; font-size:large;";>';
        echo '<img src="/templates/base/images/icons/16x16/dialog_icon_warning.png" style="vertical-align:middle; align:left;margin:5px;"/>';
        echo 'System encountered the following errors';
        echo '<img src="/templates/base/images/icons/16x16/dialog_icon_warning.png" style="vertical-align:middle; align:right; margin:5px;"/>';
        echo '</td>';
        echo '</tr>';
        foreach ($safe_error_buffer as $error) {
            foreach ($error as $k => $v) {
                echo '<tr style="text-align:left;">';
                echo '<td class="mytablealt">' . $k . '</td>';
                echo '<td>';
                if('bt' == $k) {
                    safe_debug_info(true, $v);
                }else if (is_array($v)){
                    echo '<pre>' . print_r($v, TRUE) . '</pre>';
                }else{
                    echo $v;
                }
                echo '</td>';
                echo '</tr>';
                if($error['bt']) {
                }
            }
            echo '<tr>';
            echo '<td colspan=2 class="mytablesubheader"/>';
            echo '</tr>';
        }
        /*
        echo '<tr>';
        echo '<td colspan=2>';
        safe_debug_info();
        echo '</td>';
        echo '</tr>';
        */
        echo '<tr>';
        echo '<td class="mytableheader " colspan="2" style="text-align:center; color:red;";>';
        echo '&nbsp';
        echo '</td>';
        echo '</tr>';
        echo '</table>';
        echo '</div>';
    }
}
function safe_back($offset = - 1)
{
    echo '
      <script type="text/javascript">
  window.history.go(' . $offset . ');
  </script>';
}
/*
    * set default value in params
    */
function safe_set_default($params,$key,$default_value){
    if(isset($params[$key]) && $params[$key]!==null){
        return $params[$key];
    }else{
        return $default_value;
    }
}

/* similar to above but shorter */
function safe_array_get(&$var, $default=null) {
    return isset($var) ? $var : $default;
}

function &safe_inner_array_push(&$arr, $key, $value) {
    if (!isset($arr[$key])) {
        $arr[$key] = array($value);
    } else {
        array_push($arr[$key], $value);
    }

    return $arr[$key];
}

/* get recursively */
function safe_array_list_get($var, $list, $default=null) {
    foreach ($list as $key) {
        if (!isset($var[$key])) {
            return $default;
        }

        $var = $var[$key];
    }

    return $var;
}

/* compact switch/case with arrays */
function safe_array_matcher($value, $allmatches, $default) {
    foreach ($allmatches as $ret => $matches) {
        if (in_array($value, $matches)) {
            return $ret;
        }
    }

    return $default;
}

$file_lock = null;

function safe_enter_critical_section() {
    global $file_lock;
    if(!$file_lock) {
        $file_lock = fopen(SAFE_FILE_LOCK, "w+");
    }
    if(!$file_lock)
        die('Fail to access ' . SAFE_FILE_LOCK);

    // Exclusive access
    if(!flock($file_lock, LOCK_EX))
        die('Fail to lock ' . SAFE_FILE_LOCK);

    fwrite($file_lock, gmdate(DATE_RFC822).PHP_EOL);
    fwrite($file_lock, 'PID:'.getmypid().PHP_EOL);
    // Add callback in case we die after this point
    register_shutdown_function(safe_leave_critical_section);
}

function safe_leave_critical_section() {
    global $file_lock;
    if($file_lock) {
        $fd = $file_lock;
        $file_lock = null;
        flock($fd, LOCK_UN);
        fclose($fd);
    }
}


/**
    * Test if port_data and sp_port_data is conflict
    * @param array $port_data = ('port','ip','type')source port data
    * @param array $sp_port_data = ('port','ip','type')specific port data
    */
function safe_check_port_conflict($port_data, $sp_port_data) {
    $port = $port_data['port'];
    $ip = $port_data['ip'];
    $type = $port_data['type'];
    $sp_port = $sp_port_data['port'];
    $sp_ip = $sp_port_data['ip'];
    $sp_type = $sp_port_data['type'];
    if (empty($type)) $type ='TCP';
    if (empty($sp_type)) $sp_type ='TCP';

    $type     = strtoupper(str_ireplace( array ('TLS','ALL'), array('TCP','TCPUDP'), $type));
    $sp_type  = strtoupper(str_ireplace( array ('TLS','ALL'), array('TCP','TCPUDP'), $sp_type));
    $ip       = strtoupper(trim($ip));
    $sp_ip    = strtoupper(trim($sp_ip));
    $tcp = false;
    $udp = false;
    if(strpos($type,'TCP')!==false && strpos($sp_type,'TCP')!==false) $tcp = true;
    if(strpos($type,'UDP')!==false && strpos($sp_type,'UDP')!==false) $udp = true;
    if($tcp || $udp){
        if($port == $sp_port){
            $port_used = true;
            if( $ip == 'ALL' || $sp_ip == 'ALL'){
            }else{
                if($ip != $sp_ip){
                    $port_used = false;
                }
            }
        }else{
            $port_used = false;
        }
    }else{
        $port_used = false;
    }
    return $port_used;
}
/**
    * @brief safe_create_enum_list() add default enumeration optional value and label
    *
    *  @param[in out] $type - (string) Object type
    *  @param[in out] $add_none (string) Add none entry in enumeration or not
    *  ADD_NONE_ALWAYS => always add the none option
    *  ADD_NONE_NEVER  => never add the none option
    *  ADD_NONE_IF_EMPTY => only add the none option when the enum list is empty
    *
    *  @param[in out] $optional - (boolean) Is none optional
    *  when true: Add __none__ in enumeration -> No value selected as part of optional selection,
    *      this is allowed meaning user don't want to select one - no specific validation rule.
    *  when false: Add __selectone__ to enumeration -> No value selected, this should turn into a rule
    *      validating __selectone__ is not selected, meaning selection is MANDATORY
    *
    *  @param[in out] $none_label - (string) None enumeration label, default= '( None )', optional
    *
    *  Return an array of obj name list for enumeration
    *
    * @return
    */
function safe_create_enum_list($data = array(), $add_none = ADD_NONE_ALWAYS, $optional = false, $none_label = null ) {
    if($add_none == ADD_NONE_NEVER){
        return $data;
    }else{
        $tmp_rs = array();
        if($optional){
            if($none_label){
                $tmp_rs['__none__'] = $none_label;
            }else{
                $tmp_rs['__none__'] = '( None )';
            }
        }else{
            if($none_label){
                $tmp_rs['__selectone__'] = $none_label;
            }else{
                $tmp_rs['__selectone__'] = '( Please Select One )';
            }
        }
        if($add_none == ADD_NONE_ALWAYS){
            return array_merge($tmp_rs, $data);
        }else{
            if($data){
                return $data;
            }else{
                return $tmp_rs;
            }
        }
    }
}
function safe_cidr_match_str($ipaddr, $cidr) {
    $ip = '';
    foreach (explode('.', $ipaddr) as $val) {
        $ip = $ip . str_pad(decbin($val), 8, '0', STR_PAD_LEFT);
    }
    list($subnet, $mask) = explode('/',$cidr);
    $s_ip = '';
    foreach (explode('.', $subnet) as  $val) {
        $s_ip = $s_ip . str_pad(decbin($val), 8, '0', STR_PAD_LEFT);
    }
    return (substr($ip,0,$mask) === substr($s_ip,0,$mask)) ;
}
function safe_format_button($buttons){
//delete[unbind]:confirm
    $tmp_buttons = array();
    if($buttons){
        $line_buttons = explode('|', $buttons);
        foreach($line_buttons as $button){
        
            if(strpos($button, ":") === false){
                $button_type = 'button';
            }else{
                list($button,$button_type) = explode(':', $button);
            }
            $first=strpos($button, "[");
            $next=strpos($button, "]");
            if( $first !== false &&  $next !== false &&  ($first < $next) ){
                list($button_id, $button_value) = explode('[', $button);
                list($button_value) = explode(']', $button_value);
            }else{
                $button_id = $button;
                $button_value = $button;
            }
            $button_id = strtolower(trim($button_id));
            $tmp_buttons[$button_id]['id']=$button_id;
            $tmp_buttons[$button_id]['value']=$button_value;
            $tmp_buttons[$button_id]['type']=trim($button_type);
        }
    }
    return $tmp_buttons;
}
function safe_format_bytes($bytes, $precision = 2) { 
    $units = array('B', 'KB', 'MB', 'GB', 'TB'); 

    $bytes = max($bytes, 0); 
    $pow = floor(($bytes ? log($bytes) : 0) / log(1024)); 
    $pow = min($pow, count($units) - 1); 

    // Uncomment one of the following alternatives
    // $bytes /= pow(1024, $pow);
    $bytes /= (1 << (10 * $pow)); 

    return round($bytes, $precision) . ' ' . $units[$pow]; 
}

/*
 * Some IP helper functions
* from  https://mebsd.com/coding-snipits/php-ipcalc-coding-subnets-ip-addresses.html
*/


// convert cidr to netmask
// e.g. 21 = 255.255.248.0
function safe_cidr2netmask($cidr)
{
    for( $i = 1; $i <= 32; $i++ )
        $bin .= $cidr >= $i ? '1' : '0';

    $netmask = long2ip(bindec($bin));

    if ( $netmask == "0.0.0.0")
        return false;

    return $netmask;
}

function safe_get_ip_type($ip){
    if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)){
        return SAFE_IPV6;
    }elseif(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)){
        return SAFE_IPV4;
    }else{
        return false;
    }
}
function safe_get_ip_max_prefix($type){
    $max_prefix = array('4' => 32, '6' => 128);
    if(isset($max_prefix[$type])){
        return $max_prefix[$type];
    }else{
        return false;
    }
}

// get network address from cidr subnet
// e.g. 10.0.2.56/21 = 10.0.0.0
function safe_cidr2network($ip, $cidr)
{
    if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)){
        //v6
        $network = safe_ipv6_cidr2network($ip, $cidr);
    }else{
        //v4
        $network = long2ip((ip2long($ip)) & ((-1 << (32 - (int)$cidr))));
    }
    return $network;
}

// convert netmask to cidr
// e.g. 255.255.255.128 = 25
function safe_netmask2cidr($netmask)
{
    $bits = 0;
    $netmask = explode(".", $netmask);

    foreach($netmask as $octect)
        $bits += strlen(str_replace("0", "", decbin($octect)));

    return $bits;
}

// is ip in subnet
// e.g. is 10.5.21.30 in 10.5.16.0/20 == true
//      is 192.168.50.2 in 192.168.30.0/23 == false
function safe_cidr_match($ip, $network, $cidr)
{
    if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)){
        //v6
        $ip_range = safe_ipv6_to_range($network, $cidr);
        $first_ip = safe_ip2long6($ip_range[0]);
        $last_ip = safe_ip2long6($ip_range[1]);
        $this_ip = safe_ip2long6($ip);
        return $this_ip >= $first_ip && $this_ip<= $last_ip;
    }else{
        //v4
        if ((ip2long($ip) & ~((1 << (32 - $cidr)) - 1) ) == ip2long($network)){
            return true;
        }
    }
    return false;
}

function safe_get_ip_range($ip, $ip_nmask) {
    $hosts = array();
    //convert ip addresses to long form
    $ip_address_long = ip2long($ip);
    $ip_nmask_long = ip2long($ip_nmask);

    //caculate network address
    $ip_net = $ip_address_long & $ip_nmask_long;

    //caculate first usable address
    $ip_host_first = ((~$ip_nmask_long) & $ip_address_long);
    $ip_first = ($ip_address_long ^ $ip_host_first) + 1;

    
    //caculate broadcast address
    $ip_broadcast_invert = ~$ip_nmask_long;
    $ip_broadcast = $ip_address_long | $ip_broadcast_invert;
    
    //on 64 bit machine return negative number
    //the ip2long just use low 32bit
    //1111111111111111111111111111111100001010000010100110000111111111
    $ip_broadcast = ip2long(long2ip($ip_broadcast));
    
    //caculate last usable address
    $ip_last = $ip_broadcast - 1;

    $block_info = array(
            "network" => $ip_net,
            "first_host" => $ip_first,
            "last_host" => $ip_last,
            "broadcast" => $ip_broadcast
            );

    return $block_info;
}
function safe_create_ip_range($ip, $cidr) {
    if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)){
        //v4
        $ip_nmask = safe_cidr2netmask($cidr);
        $ip_range = safe_get_ip_range($ip, $ip_nmask);
        $first_ip = long2ip($ip_range['first_host']);
        $last_ip = long2ip($ip_range['last_host']);
        $ip_list = array();
        $tmp_ip = $first_ip;
        while($tmp_ip != $last_ip){
            $ip_list[] = $tmp_ip;
            increment_ip($tmp_ip);
        }
        $ip_list[] = $last_ip;
        return $ip_list;
    }else{
        //v6
        $ip_range = safe_ipv6_to_range($ip, $cidr);
        $first_ip = $ip_range[0];
        $last_ip = $ip_range[1];
        $ip_list = array();
        $tmp_ip = $first_ip;
        while($tmp_ip != $last_ip){
            $ip_list[] = $tmp_ip;
            increment_ip($tmp_ip);
        }
        $ip_list[] = $last_ip;
        return $ip_list;
    }
    
}
//Expand an IPv6 Address
function safe_ipv6_expand($addr)
{
    if (strpos($addr, '::') !== false) {
        $part = explode('::', $addr);
        $part[0] = explode(':', $part[0]);
        $part[1] = explode(':', $part[1]);
        $missing = array();
        for ($i = 0; $i < (8 - (count($part[0]) + count($part[1]))); $i++){
            array_push($missing, '0000');
        }
        $missing = array_merge($part[0], $missing);
        $part = array_merge($missing, $part[1]);
    } else {
        $part = explode(":", $addr);
    }
    foreach ($part as &$p) {
        while (strlen($p) < 4) $p = '0' . $p;
    }
    $result = implode(':', $part);
    if (strlen($result) == 39) {
        return $result;
    } else {
        return false;
    }
}
//compress ipv6 address
function safe_ipv6_compress($addr)
{
    $result = inet_ntop(@inet_pton($addr));
    return $result;
}
function safe_ipv6_prefix_to_mask($prefix)
{
    $prefix = intval($prefix);
    if ($prefix < 0 || $prefix > 128) return false;
    $mask = '0b';
    for ($i = 0; $i < $prefix; $i++) {
        $mask .= '1';
    }
    for ($i = strlen($mask) - 2; $i < 128; $i++) {
        $mask .= '0';
    }
    $mask = gmp_strval(gmp_init($mask), 16);
    for ($i = 0; $i < 8; $i++) {
        $result .= substr($mask, $i * 4, 4);
        if ($i != 7) $result .= ':';
    }
    return safe_ipv6_compress($result);
}
function safe_ipv6_cidr2network($addr, $prefix)
{
    $size = 128 - $prefix;
    $addr = gmp_init('0x' . str_replace(':', '', safe_ipv6_expand($addr)));
    $mask = gmp_init('0x' . str_replace(':', '', safe_ipv6_expand(safe_ipv6_prefix_to_mask($prefix))));
    $prefix = gmp_and($addr, $mask);
    $start = gmp_strval(gmp_add($prefix, '0x0'), 16);
    for ($i = 0; $i < 8; $i++) {
        $start_result .= substr($start, $i * 4, 4);
        if ($i != 7) $start_result .= ':';
    }
    return safe_ipv6_compress($start_result);
}
function safe_ipv6_to_range($addr, $prefix)
{
    $size = 128 - $prefix;
    $addr = gmp_init('0x' . str_replace(':', '', safe_ipv6_expand($addr)));
    $mask = gmp_init('0x' . str_replace(':', '', safe_ipv6_expand(safe_ipv6_prefix_to_mask($prefix))));
    $prefix = gmp_and($addr, $mask);
    //if $prefix = 128 start ip = end ip
    if($size > 0){
        $start = gmp_strval(gmp_add($prefix, '0x1'), 16);
    }else{
        $start = gmp_strval($prefix, 16);
    }
    $end = '0b';
    for ($i = 0; $i < $size; $i++) $end .= '1';
    $end = gmp_strval(gmp_add($prefix, gmp_init($end)), 16);
    for ($i = 0; $i < 8; $i++) {
        $start_result .= substr($start, $i * 4, 4);
        if ($i != 7) $start_result .= ':';
    }
    for ($i = 0; $i < 8; $i++) {
        $end_result .= substr($end, $i * 4, 4);
        if ($i != 7) $end_result .= ':';
    }
    $result = array(safe_ipv6_compress($start_result), safe_ipv6_compress($end_result));
    return $result;
}
function safe_ip2long6($ip) {
    $full_ip = safe_ipv6_expand($ip);
    $ip = explode(':', $full_ip);
    $r_ip = '';
    foreach ($ip as $v) {
        $r_ip .= str_pad(base_convert($v, 16, 2), 16, 0, STR_PAD_LEFT);
    }
    //return IPv6 long in string format 
    return gmp_strval(gmp_init($r_ip,2),10);
}
function safe_icon($type, $color_class='info', $properties = array()){
    $property_string = '';
    if(!is_array($properties)){
        $property_string = 'fa-'.$properties;
    }else{
        foreach($properties as $property){
            $property_string .= ' fa-'. $property;
        }
    }
   
    if($color_class != ''){
        $color_class = 'safe_' . $color_class;
    }else{
        $color_class = '';
    } 

    $icon = " <i class='fa fa-{$type} fa-fw {$property_string} {$color_class}'></i> ";
    return $icon;
}
function safe_get_interface_type($name=''){
    $ip_type = '4';
    $type = explode('-', $name);
    if(isset($type[1]) && $type[1] != '4'){
        $ip_type = '6';
    }
    return 'ipv'.$ip_type;
}

/**
 *
 * This method generate the key for aes encrypt
 *
 * @return string 16 byte key
 */
function safe_aes_getkey($data){
    $key = substr(md5($data), 8, 16);
    return $key;
}
/**
 *
 * This method pad the data to a certain length with "\0"
 *
 * @return string
 */
function safe_aes_pad($data){
    $len = strlen($data);
    $td = mcrypt_module_open(MCRYPT_RIJNDAEL_128, '', MCRYPT_MODE_CBC, '');
    $size = mcrypt_enc_get_iv_size($td);
    mcrypt_module_close($td);
    $data  = str_pad($data, $size - $len % $size, "\0");
    return $data;
}
/**
 *
 * This method encrypts data(AES)
 *
 * @return string with base64_encode
 */
function safe_aes_encrypt($data, $key) {
    $data = safe_aes_pad($data);
    $td = mcrypt_module_open(MCRYPT_RIJNDAEL_128, '', MCRYPT_MODE_CBC, '');
    $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_RAND);
    mcrypt_generic_init($td, $key, $iv);
    $encrypted = mcrypt_generic($td, $data);
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);
    return base64_encode($iv . $encrypted);
}
/**
 *
 * This method decrypt data(AES)
 *
 * @return string
 */
function safe_aes_decrypt($data, $key) {
    $data = base64_decode($data);
    $td = mcrypt_module_open(MCRYPT_RIJNDAEL_128, '', MCRYPT_MODE_CBC, '');
    $size = mcrypt_enc_get_iv_size($td);
    $iv = substr($data, 0, $size);
    mcrypt_generic_init($td, $key, $iv);
    $data = substr($data, $size);
    $text = mdecrypt_generic($td, $data);
    mcrypt_generic_deinit($td);
    mcrypt_module_close($td);
    return trim($text);
}

function safe_encrypt_password($data) {
    $key = safe_aes_getkey($data);
    $tmp_data[0] = safe_aes_encrypt($data, $key);
    $tmp_data[1] = strlen($tmp_data[0]);
    $tmp_data[2] = base64_encode($key);
    $tmp_data[3] = strlen($tmp_data[2]);
    return base64_encode(implode('@', $tmp_data));
}

function safe_decrypt_password($data) {
    //check if the  password is encrypt
    $data = base64_decode($data, true);
    if($data !== false){
        $tmp_data = explode( '@', $data );
        if(count($tmp_data) == 4 
            && strlen($tmp_data[0]) == $tmp_data[1]
            && strlen($tmp_data[2]) == $tmp_data[3] ){
            return safe_aes_decrypt($tmp_data[0], base64_decode($tmp_data[2]));
        }
    }
    return false;
}

/* random string */
function rand_string( $length ) {
    $chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./';
    $size = strlen( $chars );
    for( $i = 0; $i < $length; $i++ ) {
        $str .= $chars[ rand( 0, $size - 1 ) ];
    }
    return $str;
}
// hash type (from http://www.akkadia.org/drepper/SHA-crypt.txt)
// 1 = MD5 //22 byte
// 5 = SHA256//43 byte
// 6 = SHA512//86 byte
function safe_hash_password($data, $type = '1'){
    $salt = rand_string(5);
    $tmp_string = '$' . $type . '$' . $salt . '$';
    return crypt($data, $tmp_string);
}
function safe_is_hash_password($data){
    $tmp_array = explode('$' , $data );
    $hash_len = array('1' => 22, '5' => 43, '6' => 86 );
    if(count($tmp_array) == 4
            && in_array($tmp_array[1], array_keys($hash_len))
            && strlen($tmp_array[3]) == $hash_len[$tmp_array[1]]){
        return true;
    }
    return false;
}

/**
 * @brief Clear $_SESSION data used for product info caching
 *
 * TODO: Ideally all 'cached' session data should be stored in $_SESSION['cache'] 
 * array entry so we don;t have to maintain a list of cached 'entries'
 * Doing so will require adding functions like:
 *   - safe_session_set_cache($entry, $data)
 *   - safe_session_get_cache($entry)
 * @return 
*/
function safe_session_clear_cache(){
    // Ensure we clear 'cached' session data, as of writting:
    // * menu entries -> $_SESSION['pagedata']
    // * Product definition XML - $_SESSION['prod-def']
    $_cached_entries = array('pagedata', 'prod-def');
    session_start();
    foreach($_cached_entries as $_entry){
        if(isset($_SESSION[$_entry])){
            unset($_SESSION[$_entry]);
        }
    }
    session_write_close();
}
//case-insensitive in_array()
function safe_in_arrayi($needle, $haystack) {
    return in_array(strtolower($needle), array_map('strtolower', $haystack));
}

function safe_trim($str) {
    if(is_string($str)){
        $str = trim($str);
    }
    return $str;
}

function safe_log($level = SAFE_LOG_ERROR, $message = '' ) {
    if($message){
        if(is_array($message)){
            foreach($message as $item){
                error_log("{$level} - {$item}");
            }
        }else{
            error_log("{$level} - {$message}");
        }
    }
}
function safe_need_reboot() {
    //after upgrade need to reload prod_def
    $reboot_file = "/var/sng/ui/reboot.json";
    if(file_exists($reboot_file)){
        $buffer = Safe_sudo_exec('/bin/cat ' . $reboot_file, '', '', $rc);
        if(0 === $rc){
            $buffer = implode($buffer, '');
            $reboot_data = json_decode($buffer, true);
            if(!empty($reboot_data)){
                $result['reboot'] = $reboot_data;
                $result['reboot_request'] = true;
                return $result;
            }
        }
    }
    return false;
}
function safe_set_session($key, $value){
    session_start();
    if(is_array($value) || is_object($value)){
        $_SESSION[$key] = serialize($value);
    } else {
        $_SESSION[$key] = $value;
    }
    session_write_close();
}
function safe_unset_session($key){
    session_start();
    if(isset($_SESSION[$key])){
        unset($_SESSION[$key]);
    } else {
        return null;
    }
    session_write_close();
}
function safe_get_session($key){
    if(isset($_SESSION[$key])){
        $data = @unserialize($_SESSION[$key]);
        if ($data !== false){
            return $data;
        } else {
            return $_SESSION[$key];
        }
    } else {
        return null;
    }
}

/* End of file safe_helper.php */
