<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/*
 * SAFe object classes
*/
require_once ('application/helpers/safe_helper.php');
require_once ('safe_object_class.php');
class Safe_ip_address_class extends Safe_configurable_object_class
{
    const IP_V4 = '4';
    const IP_V6 = '6';
    const PROTO_STATIC4 = 'static-4';
    const PROTO_STATIC6 = 'static-6';
    const PROTO_DHCP4 = 'dhcp-4';
    const PROTO_DHCP6 = 'dhcp-6';
    const PROTO_SLAAC6 = 'slaac-6';
    const PROTO_DISABLE = 'false';
    
    protected $_address;
    protected $_prefix;
    protected $_type;
    protected $_interface;
    protected $_dhcp = array(Safe_ip_address_class::PROTO_DHCP4, Safe_ip_address_class::PROTO_DHCP6, Safe_ip_address_class::PROTO_SLAAC6);
    protected $_static = array(Safe_ip_address_class::PROTO_STATIC4, Safe_ip_address_class::PROTO_STATIC6);
    
    /**
    * Constructor for ip address config class
    * @param $node
    * @param $parent_name
    * @param $name
    */
    public function __construct($node, $parent_name, $name)
    {
        // Parent constructor to invoke unserialize if needed
        parent::__construct($parent_name, $name, $node);
        // Do NOT re-use records on update/delete
        $this->_set_reuse(false);
    }
    //to do change function name
    public function ip_type()
    {
        return $this->_type;
    }
    public function address()
    {
        //to do add if not stattic go to backend and sync with db
        return $this->_address;
    }
    //interface prefix
    public function prefix()
    {
        return $this->_prefix;
    }
    public function netmask()
    {
    }
    public function get_interface()
    {
        return $this->_interface;
    }
    
}