<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * Safe Semaphore class
 * @author Santiago Tramoyeres Cuesta <scuesta@sangoma.com>
 *         
 */

class Safe_semaphore_class{
    private $key;
    private $res;
    private $autorelease;
    private $acquired;
    
    /**
     * @brief Constructor
     * @param string it could be filepath
     * @param int 0/1
     */
    public function __construct($filepath,$autorelease=0){
        $this->res = null;
        $this->autorelease = $autorelease;
        $this->key = ftok($filepath,"A");
        $this->acquired = false;
    }

    /**
     * @brief Locks semaphore to prevent access from other php process to the
     * same critical secction 
     * @return boolean true/false if semaphore has been acquired properly
     */
    public function lock(){        
        if($this->key>0){
            $this->res = sem_get($this->key,1,0666,$this->autorelease);        
            $this->acquired = sem_acquire($this->res);
        }
        return $this->acquired;
    }

    /**
     * @brief Releases the semaphore acquired if no autorelease has been setted.
     * @return boolean true/false if semaphore has been released properly
     */
    public function release(){
        return !$this->autorelease && $this->acquired? sem_release($this->res) : true;
    }
}

?>