<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * Network Config wrapper page
 * @author Santiago Tramoyeres Cuesta <scuesta@sangoma.com>
 *         
 */

abstract class Safe_vinfo{
  
  protected $info;

  /* public function __construct($info=null){ */
  /*   if($info!=null) */
  /*     $this->parse($info); */
  /* } */
  
  /**
   * @brief   Sort an array of Safe_vInfo instances
   * @param   Safe_vInfo[]
   * return   Safe_vInfo[]
   */
  public static function sort(&$arrVInfo = array(),$vInfoClassName){
    $result = array();	
    foreach($arrVInfo as $vInfo){
	  $vInfo = new $vInfoClassName($vInfo);
      $result[$vInfo->to_int()] = $vInfo;
	}
    ksort($result);
    return array_values($result);
  }
  
  public function info(){
    return $this->info;
  }

  /**
   * @brief Casting function from version to int. 
   * return int
   */
  abstract public function to_int();

  /**
   * @brief Check if current release is beta version
   *        Override if needed
   * return boolean
   */ 
  abstract public function is_beta();

  /**
   * @brief Check if current release is stable
   * return boolean
   */ 
  abstract public function is_stable();

  /**
   * @brief Check if current release is development
   *        Override if needed
   * return boolean
   */
  abstract public function is_dev();

  /**
   * @brief Check if current releass is less than other
   * @param Safe_vinfo
   * return boolean
   */
  public function lth(Safe_vinfo $v){
    return $this->to_int()<$v->to_int();
  }

  /**
   * @brief Check if current release is greater than other
   * @param Safe_vinfo
   * return boolean
   */
  public function gth(Safe_vinfo $v){
    return $this->to_int()>$v->to_int();
  }

  /**
   * @brief Check if current release is equal to other
   * @param Safe_vinfo
   * return boolean
   */
  public function eq(Safe_vinfo $v){
    return $this->to_int()==$v->to_int();
  }

  /**
   * @brief Parses a version information
   * @param stdClass || Safe_version || array || Safe_vInfo
   * return array
   */
  abstract public function parse($info);

  abstract public function __toString();
}
?>