<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * William Adam <william.adam@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/*
Displays module action buttons top bar, args:
 $action_settings - Array of action settings
 $base_url        - Base url for action
 $url_suffix      - Suffix to add after action (usually module/obj)
 $action_param_suffix - Suffix to add to action url if action as parameters (like _form)
   
 */
if(empty($action_settings)){
  return;
}
echo "
<style type='text/css'>

</style>

    ";
echo "<div class='safe_button_container'>";

foreach($action_settings as $action => $def){
    if(isset($def['display']) && $def['display'] === false){
        continue;
    }
    $action_url = '';
    if(empty($def['icon'])){
        $def['icon'] = 'gear';
    }
    if(isset($def['class']) || isset($def['confirm']) || isset($def['processing'])){
        if($def['class']){
            //with a popup form
            $tmp_url = $base_url . '/' . 'action_form'. '/' . $module_name . '/';
            $clikc_method = 'safe_handle_create_button(this);';
        }elseif($def['confirm']){
            //with a confirm dialog
            $tmp_url = $base_url . '/' . 'action_confirm'. '/' . $module_name . '/';
            $clikc_method = 'safe_handle_confirm_button(this);';
        }else if($def['processing']){
            $tmp_url = $base_url;
            $clikc_method = 'safe_handle_processing_button(this);';
        }
        $action_url = $tmp_url.$action;
    }else{
        $action_url = $base_url.$action;
        $clikc_method = 'safe_handle_create_button(this);';
    }
    // Action as parameters ? - Know exception is upload
    if($action_param_suffix){
        $action_url .= $action_param_suffix;
    }
    if($url_suffix){
        $action_url .= $url_suffix;
    }
    if(!$def['button_class']){
        $def['button_class'] = 'primary';
    }
    //overwrite the url
    if(isset($def['action_url'])){
        $action_url = $def['action_url'];
    }
    //work like a button
    if(isset($def['button']) && $def['button']){
        $clikc_method = '$(this).closest("form").submit();';
    }

    echo "<form action='".$action_url."' method='".$def['request']."' enctype='multipart/form-data'>";
    echo "<a class='safe_button_action safe_button_".$def['button_class']." css_right' onclick='{$clikc_method}' name='".$action."'>";
    echo safe_icon($def['icon'], 'button_icon');
    echo "<span class='safe_button_label'>";
    echo $def['name'];
    echo "</span>";
    echo "</a>";
    if($def['execute']){
        echo '<script type="text/javascript">';
        echo "CALLBACKS['".$def['execute']."'].apply(window,".(isset($def['args'])? json_encode($def['args']) : '[]').");";
        echo '</script>';
    }
    echo "</form>";

}

echo "</div>";
echo "<div class='css_clear'></div>";
?>
