<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/*
View parameters (to pass as $data['xxx']):
- min_line => Minimum number of line in each container
- tabs => array of tabs
   - id      => Id of content container (optional)
   - title   => Tab title
   - mode    => display mode: table(default), paragraph, pre
   - content => Tab content
*/
if (isset($tables)) {
    $tabs = $tables;
}
if (isset($tabs)) {
?>
<div id="safe_tabs"  style="display: none;" class="no-header">
<?php
    if (!isset($min_line)) $min_line = 50;
    // Create Tab layout
    echo '<ul>';
    // Following line is because jquery-ui tab behaviour
    $tab_id_url = 1;
    foreach ($tabs as $tab_id => $tab) {
        if (isset($tab['ref']))
            $tab_ref = $tab['ref'];
        else if (isset($tab['id'])) $tab_ref = $tab['id'];
        else $tab_ref = 'safe_tab_' . $tab_id;
        $is_url = preg_match('#^http|^/#',$tab_ref);
        $tab_id = $is_url? 'id="ui-id-'.$tab_id_url.'"' : '';
        $tab_ref = $is_url? $tab_ref : '#'.$tab_ref;
        $cache = isset($tab['cache'])? 'cache="'.$tab['cache'].'"' : '';
        echo '<li><a href="' . $tab_ref . '" '.$tab_ref.' '.$cache.'>' . $tab['title'] . '</a></li>';
        //        $tab_id++;
    }
    echo '</ul>';
    if(isset($content_wrapper)){
        echo '<div id="safe_content_wrapper">';
    }
    // Create tab content
    $tab_id_url = 1;
    foreach ($tabs as $tab_id => $tab) {
        if(isset($tab['ref']))
            $tab_ref = $tab['ref'];
        else if (isset($tab['id'])){
            $tab_ref = $tab['id'];
        }else{
            $tab_ref = 'safe_tab_' . $tab_id;
        }
        $is_url = preg_match('#^http|^/#',$tab_ref);
        if($is_url)
            continue;

        echo '<div id="' . $tab_ref . '" >';
        if (!isset($tab['type'])) {
            if (!is_array($tab['content'])) {
                $tmp = $tab['content'];
                unset($tab['content']);
                $tab['content'] = array(
                        $tmp
                );
            }
        }
        
        $tab_open = '<div class="safe_tabs_table %s widget-content-body ui-state-active mytable" %s>';
        $mode = (isset($tab['mode'])) ? $tab['mode'] : 'table';
        switch ($mode) {
        case 'paragraph':
            $open = '';
            $close = '';
            $open_line = '<p class="safe_tab_content %s">';
            $close_line = '</p>';
            break;

        case 'pre':
            $open = '<pre>';
            $close = '</pre>';
            unset($open_line);
            $close_line = '</br>';

            $open = '';
            $close = '';
            $open_line = '<pre>';
            $close_line = '</pre>';
            break;

        case 'table':
        default:
            $open = '<table class="safe_tab_content %s">';
            $close = '</table>';
            $open_line = '<tr class="%s"><td class="safe_tab_td">';
            $close_line = '</td></tr>';
            break;
        }
        $i = 0;
        //$tab['content'] = array_merge($tab['content'],array_fill(0, 50,"&nbsp;"));
        // Open the tab container according to mode

        if(isset($tab['type']) && $tab['type'] == 'obj'){
            echo sprintf($tab_open, 'safe_tabs_table_obj ui-corner-bottom ui-corner-top', 'id="content_' . $tab_id . '"');
            echo sprintf($open, 'safe_tab_content_obj');
            $tmp_array = explode(' ', $tab['content']);
            echo sprintf($open_line, '');
            echo $tab['content'];
            echo $close_line;
        }else{
            echo sprintf($tab_open, '', 'id="content_' . $tab_id . '"');
            echo sprintf($open, '');
            foreach ($tab['content'] as $content) {
                $class = ($i % 2) ? 'odd' : 'even';
                // Open the line
                if (isset($open_line)) echo sprintf($open_line, $class);
                // Display content
                echo $content;
                // close the line
                if (isset($close_line)) echo $close_line;
                $i++;
            }
        }
        echo $close;
        echo '</div>';
        echo '</div>';
    }
    if(isset($content_wrapper)){
        echo '</div>';
    }
?>
</div><!-- safe_tabs ends -->
<?php
}
if(isset($tab['scroll'])){
    echo "<script>var scroll_type='{$tab['scroll']}';</script>";
}
?>
