(function($,window){
    var hourly_data =[],
        values = [],
        Infinity=10000000,
        increment=10;
    var plotObjects = [{max:0,min:Infinity,serie_settings:{label:'Last Calls per Second',color:"rgb(0,136,204)"},chart_selector:'cps',text_selector:'#text-current_cps',field:'current_cps',selector:'#main-chart'},                       
                       {max:0,min:Infinity,serie_settings:{label:'Current simultaneous Calls',color:"rgb(0,136,204)"},chart_selector:'csc',text_selector:'#text-current_calls',field:'current_calls',selector:'#main-chart'},
                       {max:0,min:Infinity,serie_settings:{label:'Max. CPS last 5 mins.',color:"rgb(0,136,204)"},chart_selector:'l5cps',text_selector:'#max-last_5min_cps',field:'last_5min_cps',selector:'#main-chart'},                  
                       {max:0,min:Infinity,text_selector:'#max-current_cps',field:'current_cps'}];
    var max_cps_gauge =  $('#max-cps'),
        max_cps = 0,
        max_csc_gauge =  $('#max-csc'),
        max_csc = 0,
        curr_chart = 'csc',
        last_data = undefined;
    var update = function(data){
        var default_settings = {
            series:{
                shadowSize:0
            },
            yaxis:{
                min:0,
                max:0
            },
            xaxis:{
                show:false
            },
            grid:{
                hoverable:true
            }
        };
        var eq=true;
        if(last_data){
            for(var i in data)           
                if(last_data[i]==undefined || last_data[i]!=data[i])
                    eq=false;
        }else
            eq=false;
        if(data && !eq){
            last_data=data;            
            var threshold_fields = {current_cps:'calls_per_second_limit',current_calls:'calls_limit'};
            $.each(plotObjects,function(j,obj){                                        
                    values[j].push([values[j][values[j].length-1][0]+1, data[obj.field]]);
                    values[j].splice(0,1);
                    // if(threshold_fields[obj.field])
                    //     obj.serie_settings.threshold.below = 0.85*data[threshold_fields[obj.field]];
                    
                    if(obj.max<data[obj.field])
                        obj.max=data[obj.field];
                    if(obj.min>data[obj.field])
                        obj.min=data[obj.field];
                    if(obj.text_selector=='#max-'+obj.field)
                        $(obj.text_selector).html(obj.max);
                    else if(obj.text_selector=='#text-'+obj.field)
                        $(obj.text_selector).html(data[obj.field]);
                });
            $('#text-max_cps_since_startup').html(data.max_cps_since_startup);
        }
        $.each(plotObjects,function(j,obj){
                if(obj.serie_settings && curr_chart==obj.chart_selector){
                    obj.serie_settings.data = values[j];
                    default_settings.yaxis.max = obj.max+increment;
                    default_settings.yaxis.min = obj.min-increment;                    
                    $.plot(obj.selector,[obj.serie_settings],default_settings);
                }
            });
        
        // if(window.cps_update_ticker)
        //     clearTimeout(window.cps_update_ticker);

        window.cps_update_ticker = setTimeout(function(){
                    $.ajax({
                            url:'/SAFe/sng_cps/update?_='+(new Date()).getTime(),
                            success:update,
                            dataType:'json'
                        });
                },2000);
    }
    
    var fill_data = function(data){
        for(var i in data)
            hourly_data=hourly_data.concat(data[i]);
        
        for(var i=0;i<plotObjects.length;i++)
            values.push([]);
        var length = hourly_data.length,
        i=(length>100)? length-100 : 0;
        while(++i<length){
            $.each(plotObjects,function(j,obj){
                    var val = hourly_data[i][obj.field];
                    if(obj.max<val)
                        obj.max=val;
                    if(obj.min>val)
                        obj.min=val;
                    values[j].push([values[j].length,hourly_data[i][obj.field]]);
                });
        }
        update();
    }
    
    // Fill main-chart 
    $.ajax({
            url:'/SAFe/sng_cps/hourly',
                success:fill_data,
                dataType:'json'
                });
    
    var aggregate_charts = function(){
        // Fill daily and weekly charts
        var default_settings = {bars: {show: true,barWidth: 0.6,align: "center"},xaxis: {mode: "categories",tickLength: 0}};

        $.each(['weekly','daily'],function(i,key){
                var fields = {'cps':'max_cps','csc':'max_simultaneous_calls'};
                if(fields[curr_chart]){
                    $.ajax({
                            url:'/SAFe/sng_cps/'+key+'?_='+(new Date()).getTime(),
                                success:function(data){
                                var values = [];
                                for (var i in data){
                                    for(var j in data[i]){
                                        var time = new Date(data[i][j].timestamp*1000),
                                            month = time.getMonth()+1,
                                            day = key=='daily'? time.getDate() : j;
                                        day = day<9? '0'+day : day;
                                        month = month<9? '0'+month : month;
                                        
                                        var k = key=='daily'? month+'/'+day : time.getFullYear()+'/'+day;
                                        
                                    values.push([k,data[i][j][fields[curr_chart]]]);
                                    }
                                }
                                var length = values.length,
                                    i=-1;
                                if(length>10)
                                    values = values.splice(0,length-10);
                                length = values.length;
                                if(length<10){
                                    var k = values[0][0].match(/([0-9]+)\/([0-9]+)$/),
                                        k0 = parseInt(k[1]),
                                        k1 = parseInt(k[2]),
                                        j = k1-3,
                                        key2='unknow',
                                        aux = [];
                                    while(++j<k1){
                                        switch(key){
                                        case 'daily':
                                            var time = new Date();
                                            time.setMonth(k0-1);
                                            time.setDate(1);
                                            time.setDate(j);
                                            var month = time.getMonth()+1;
                                            month = month<9? '0'+month : month;
                                            key2 = month+'/'+time.getDate();
                                            break;
                                        case 'weekly':
                                            var day = j;
                                            var year = k0;
                                            if(j<0){
                                                day=365-j;
                                                year = k0-1;
                                            }
                                            day = day<9? '0'+day : day;
                                            key2 = year+'/'+day;
                                            break;
                                        }
                                        aux.push([key2,0]);
                                    }
                                    values = aux.concat(values);                                
                                }
                                $.plot('#'+key+'-chart',[{color:"rgb(0,136,204)",data:values}],default_settings);
                            },
                                dataType:'json'
                                });                
                }
            });            
    };
    
    aggregate_charts();
    
    //Main chart buttons behaviour
    $('#main-chart-buttons label').on('click',function(){
            // **** Button behaviour ***** 
            var actived = $('label.safe_button_primary',$(this).parent());
            actived.removeClass('safe_button_primary').addClass('safe_button_default');
            $(this).removeClass('safe_button_default').addClass('safe_button_primary');
            actived.next().prop('checked',false);
            
            actived = $(this);
            actived.next().prop('checked',true);
            // *************************
            
            // Curr_chart is a global function of cps scope that let us choose
            // the data values we want to see in the main chart.
            
            curr_chart = actived.next().val();
            // **** Title behaviour *****

            $('#main-chart-title-container h2:visible').hide();
            $('#main-chart-title-container .'+curr_chart).show();
            var newVisibleTitle = $('#aggregate-charts h2.'+curr_chart);
            if(newVisibleTitle.length){
                $('#aggregate-charts h2:visible').hide();
                $('#aggregate-charts h2.'+curr_chart).show();
            }
            clearTimeout(window.cps_update_ticker);
            update();
            // *************************            
            aggregate_charts();
        });
    

    // Plothover
    // var tooltip = $('#tooltip');
    // if(tooltip.length)
    //     $('.plotclick').bind("plotclick",function(event,pos,item){
    //             var value = $('.value-info',this);
    //             value.html('');
    //             value.html(item.
    //     });
    
    // Responsive behaviour
    var responsiveObjects = ['#calls_per_second ul.col-3','#calls_per_second .col-6', '#aggregate-charts .col-5'];    
    var responsiveBackup = [];
    var length = responsiveObjects.length,
        i = -1;
    while(++i<length){
        responsiveObjects[i] = $(responsiveObjects[i]);
        responsiveBackup.push(responsiveObjects[i].attr('class'));
    }
    
    var responsive = function(){
        var wwidth = $(this).width();
        var i = -1;
        if(wwidth<=1300){
            while(++i<length)
                responsiveObjects[i].attr('class',responsiveObjects[i].attr('class').replace(/col-[0-9]+/,'col-10'));
        }else
            while(++i<length)
                responsiveObjects[i].attr('class',responsiveBackup[i]);
        aggregate_charts();
    }
    
    $(window).resize(responsive);

    if(!$.ui.tabs.prototype._load25624)
        $.extend($.ui.tabs.prototype, {
                _load25624: $.ui.tabs.prototype.load,
                    load: function(index) {
                    var $active = $('a',this.active);
                    if(!$active.attr('href').match(/sng_cps/)){
                        clearTimeout(window.cps_update_ticker);
                        window.cps_update_ticker=undefined;
                    }else
                        update();
                    var cache = $active.attr('cache');
                    return !cache || cache=='false' || $(this.panels[index]).html()==''? this._load25624(index) : false;
                }
            });

    $(window).resize();
    //$('#safe_tabs').tabs('option','cache',true);
    //});
})(jQuery,window);