$.fn.dataTableExt.sErrMode = 'throw';
$.fn.dataTableExt.oPagination.four_button = {
    "fnInit": function ( oSettings, nPaging, fnCallbackDraw )
    {
        // Create new navigation controls
        nFirst = document.createElement('button');
        nFirst.setAttribute('class', 'ui-button ui-widget ui-button-icon-only css_left page-first');
        nFirstSpan = document.createElement('i');
        nFirstSpan.setAttribute('class', 'fa fa-step-backward fa-fw safe_info_i');
        nFirst.appendChild(nFirstSpan);

        nPrevious = document.createElement('button');
        nPrevious.setAttribute('class', 'ui-button ui-widget ui-button-icon-only css_left page-prev'); 
        nPreviousSpan = document.createElement('i');
        nPreviousSpan.setAttribute('class', 'fa fa-backward fa-fw safe_info_i');
        nPrevious.appendChild(nPreviousSpan);

        nNext = document.createElement('button');
        nNext.setAttribute('class', 'ui-button ui-widget ui-button-icon-only css_left page-next');
        nNextSpan = document.createElement('i');
        nNextSpan.setAttribute('class', 'fa fa-forward fa-fw safe_info_i');
        nNext.appendChild(nNextSpan);

        nLast = document.createElement('button');
        nLast.setAttribute('class', 'ui-button ui-widget ui-button-icon-only css_left page-last');
        nLastSpan = document.createElement('i');
        nLastSpan.setAttribute('class', 'fa fa-step-forward fa-fw safe_info_i');
        nLast.appendChild(nLastSpan);
        // Create page list
        nPages = document.createElement('select');
        nPages.setAttribute('class', 'page-list css_left');
        // For sure we gonna have at least one page :)
        nOption = document.createElement('option');
        nOption.text = "1";
        nOption.value = "1";
        nPages.appendChild(nOption);
        // Add the onchange function
        $(nPages).on("change",function (e) {
            var iNewStart = oSettings._iDisplayLength * (this.value - 1);
            oSettings._iDisplayStart = iNewStart;
            fnCallbackDraw(oSettings);
        });

        // Add pagination controls to navigation div
        nPaging.appendChild(nFirst);
        nPaging.appendChild(nPrevious);
        nPaging.appendChild(nPages);
        nPaging.appendChild(nNext);
        nPaging.appendChild(nLast);
        $(nFirst).on("click", function () {
            oSettings.oApi._fnPageChange( oSettings, "first" );
            fnCallbackDraw( oSettings );
        } );
        $(nPrevious).on("click", function () {
            oSettings.oApi._fnPageChange( oSettings, "previous" );
            fnCallbackDraw( oSettings );
        } );
        $(nNext).on("click", function () {
            oSettings.oApi._fnPageChange( oSettings, "next" );
            fnCallbackDraw( oSettings );
        } );
        $(nLast).on("click", function () {
            oSettings.oApi._fnPageChange( oSettings, "last" );
            fnCallbackDraw( oSettings );
        } );
    },
    "fnUpdate": function ( oSettings, fnCallbackDraw )
    {
        //console.log('in Update');
        if (!oSettings.aanFeatures.p) {
            return;
        }
        // Compute number of pages based on display lenght and total records
        var iPages = Math.ceil(oSettings.fnRecordsDisplay() / oSettings._iDisplayLength);
        var iCurrentPage = Math.ceil(oSettings._iDisplayStart / oSettings._iDisplayLength) + 1;
        var oPager = oSettings.aanFeatures.p;
        //console.log('Table total ' + oSettings.fnRecordsTotal() );
        //console.log('Table display ' + oSettings.fnRecordsDisplay() );
        //console.log('display lenght ' + oSettings._iDisplayLength );
        //console.log('Pages ' + iPages);
        //console.log('Page ' + iCurrentPage);

        // Populate page list
        nPages = $('.page-list', oPager);
        nPages.empty();
        for(var i=1; i <= iPages; i++){
            nOption = document.createElement('option');
            nOption.text = i.toString();
            nOption.value = i.toString();
            if(i == iCurrentPage){
                nOption.selected = true;
            }
            nPages.append(nOption);
        }
        // Enable/Disable navigation buttons based on current page and number of pages
        if(iPages > 1){
            // Enable all
            $('[class*="page-"]', oPager).attr('disabled', false);
        }else{
            // Disable all
            $('[class*="page-"]', oPager).attr('disabled', true);

        }
    }
};
/*clear search icon*/
(function($) {
    $.fn.clearSearch = function(options) {
        var settings = $.extend({
            'clearClass' : 'clear_input',
            'focusAfterClear' : true,
            'linkText' : '<i class="fa fa-times-circle fa-fw fa-lg safe_search_clear"></i>'
        }, options);
        return this.each(function() {
                    var $this = $(this), btn,
                        divClass = settings.clearClass + '_div';

                    if (!$this.parent().hasClass(divClass)) {
                        $this.wrap('<div style="position: relative;" class="'
                            + divClass + '">' + $this.html() + '</div>');
                        $this.after('<a style="position: absolute; cursor: pointer;" class="'
                            + settings.clearClass + '">' + settings.linkText + '</a>');
                    }
                    btn = $this.next();

                    function clearField() {
                        $this.val('').trigger("change");
                        triggerBtn();
                        if (settings.focusAfterClear) {
                            $this.focus();
                        }
                        if (typeof (settings.callback) === "function") {
                            settings.callback();
                        }
                    }

                    function triggerBtn() {
                        if (hasText()) {
                            btn.show();
                        } else {
                            btn.hide();
                        }
                        update();
                    }

                    function hasText() {
                        return $this.val().replace(/^\s+|\s+$/g, '').length > 0;
                    }

                    function update() {
                        var width = $this.outerWidth(), height = $this
                                .outerHeight();
                        btn.css({
                            top : height / 2 - btn.height() / 2 + 1.5,
                            left : width - height / 2 - btn.height() / 2 + 14
                        });
                    }

                    btn.on('click', clearField);
                    $this.on('keyup keydown change focus', triggerBtn);
                    triggerBtn();
                });
    };
})(jQuery);

/*
* l - Length changing
* f - Filtering input
* t - The table!
* i - Information
* p - Pagination
* r - pRocessing
 */

$(document).ready(function(){
    // Check local storage for tabs
    var path = $(location).attr('pathname');
    var res = path.split("/");
    path = '/' + res[1] + '/' + res[2];
    $('#safe_tabs').tabs({
        activate: function( event, ui ) {
            var active = $( "#safe_tabs" ).tabs( "option", "active" );
            var tab = { tab_index : active };
            if(typeof scroll_type !== "undefined" && scroll_type == 'bottom' ) {
                scroll_id = '#content_' + tab.tab_index;
                $(scroll_id).stop().animate({
                    scrollTop: $(scroll_id)[0].scrollHeight
                  }, 200);
            }
            //set sessionStorage
            if(typeof Storage !== "undefined") {
                sessionStorage.setItem(path, JSON.stringify(tab));
            } 
        }
        });
    //if sessionStorage set
    var local_data =  null;
    if(typeof Storage !== "undefined") {
        local_data = JSON.parse(sessionStorage.getItem(path));
    }
    var tab_index = 0;
    if(local_data !== null){
        if(typeof local_data.tab_index !== 'undefined'){
            tab_index = local_data.tab_index;
        }
    }
    
    $('#safe_tabs').css('display', 'block');
    $("#safe_tabs").tabs( "option", "active",  tab_index);
    
    try{
        resizeWrapper();
    }catch(e){
        console.log('resizeWrapper exception :(');
    }
    
    
    

    $('.safe_datatable table').each(function(){
        try{
          var table_id = this.id;
          if(this.id == ''){
              return;
          }
          var displayLength = 10;
          
          if (typeof dataTableSetting !== 'undefined' && typeof dataTableSetting[table_id] !== 'undefined') {
              displayLength = dataTableSetting[table_id];
          }
          
          var datatable_obj = $(this).dataTable(
              {
                  "bJQueryUI": true,
                  "sPaginationType": "four_button",
                  "sDom": '<"top"<"css_left"f><"css_left"l><"css_left"i><"css_right"p>><"css_clear"t><"bottom"><"clear">',
                  "bRetrieve": true,
                  "iDisplayLength": displayLength,
                  "lengthMenu": [[10, 25, 50, 100, -1], [10, 25, 50, 100, "All"]],
                  "bDestroy": true,
                  "bStateSave": true,
                  "aaSorting": [],
                  "oLanguage": {
                      "sSearch": "",
                      "sLengthMenu": "_MENU_"
                              }                  
              }
          );
         // Change search div to add icon
            var datatable_wrapper =  $(this).parent().parent();
            var searchbox = $('input:first', datatable_wrapper);
            var searchbox_lable = searchbox.parent();
            
            searchbox.addClass('ui-corner-all safe_data_search');
            nSearch = document.createElement('i');
            nSearch.setAttribute('class', 'fa fa-search fa-fw safe_info');
            nSearch.setAttribute('style', 'margin-top: 6px;margin-left: 2px;float: left;');
            searchbox_lable.prepend(nSearch);
        }catch(err){
        }
    });
    // Remove sort icon from all table column header that don't have caption 
    // (ie. button column)
    // When table is empty filter doesn't find what we are looking for, so
    // setting timeout solves the proble.
    setTimeout(function(){
            $('.DataTables_sort_wrapper').filter(function(){
                    return $(this).text() == "";
                }).children('.DataTables_sort_icon').remove()
                },50);
});

var safe_datatable_fetch_params = {};

function safeDatatableUpdate(params){
  if(params.hasOwnProperty('data')){
    var oTable = $('#' + params.async.id + '.safe_datatable table').dataTable();
    oTable.fnAddData(params.data, false);
    oTable.fnDraw(false);
  }
  safeDatatableFetch(params.async);
}

function safeDatatableFetch(params){
  params = params || {};

  // Store fetch parameters
  safe_datatable_fetch_params[params.id] = params;
  // Is fetch completed ?
  if(params.offset + params.count < params.total){
    var missing = params.total - (params.offset+params.count);

    params.offset += params.count;
    $.ajax({
      contentType: 'application/json',
      url:params.url,
      type: 'POST',
      dataType:'json',
      data: JSON.stringify(params),
      async:true,
      success:safeDatatableUpdate,
      error:(function (xhr, textStatus, thrownError){
              console.log('RX Error:' +  xhr.status + ' - ' + textStatus);
              console.log(thrownError);
        })
      });
  }
}
