<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * SNG misc debug facilities
 *
 * @author William Adam
 * @version
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
class Load extends CI_Controller
{
    private function _extenstion_to_type($extension)
    {
        switch($extension){
        case 'js': return 'text/javascript';
        case 'css': return 'text/css';
        }
        return 'text/plain';
    }
    private function _compress($buffer)
    {
        /* remove comments */
        $buffer = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $buffer);
        /* remove tabs, spaces, newlines, etc. */
        $buffer = str_replace(array("\r\n","\r","\n","\t",'  ','    ','     '), '', $buffer);
        /* remove other spaces before/after ; */
        $buffer = preg_replace(array('(( )+{)','({( )+)'), '{', $buffer);
        $buffer = preg_replace(array('(( )+})','(}( )+)','(;( )*})'), '}', $buffer);
        $buffer = preg_replace(array('(;( )+)','(( )+;)'), ';', $buffer);
        return $buffer;
    }
    private function _load($target)
    {
        $enable_gzip = false;
        $enable_compress = false;
        $segments = array_splice($this->uri->segment_array(), 2);
        $asset = BASEPATH.'../'.$target.'/'.implode('/', $segments);
        $ext = pathinfo($asset, PATHINFO_EXTENSION);
        
        $content = file_get_contents($asset);
        if( FALSE === $content){
            error_log('ERROR - load '.$target.': '.$asset.' 404 Not Found');
            header('HTTP/1.0 404 Not Found');
            show_404();
            exit();
        }
        //error_log('DEBUG - load '.$target.': '.$asset);
        if(('css' == $ext) && $enable_compress){
            $content = $this->_compress($content);
        }
        if($enable_gzip){
            $content = gzencode($content);
        }
        /* Max age in sec:
            1 day in seconds = 86400
            1 week in seconds = 604800
            1 month in seconds = 2629000
            1 year in seconds = 31536000 (effectively infinite on internet time)
         */
        $expires = 31536000;
        ob_start();
        echo $content;
        header('Content-type: '.$this->_extenstion_to_type($ext));
        if($enable_gzip){
            header('Content-encoding: gzip');
        }
        header('Content-Length: ' . ob_get_length());
        header('Cache-Control: max-age='.$expires.', private');
        header('Pragma: private');
        header('Expires: '. gmdate('D, d M Y H:i:s', time()+$expires).' GMT');
        ob_end_flush();
        return; 
    }
    public function templates()
    {
        $this->_load('templates');
    }
    public function assets()
    {
        $this->_load('assets');
    }
}
/* End of file sng_debug.php */
