<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
* Copyright (C) 2012  Sangoma Technologies Corp.
* All Rights Reserved.
*
* Author(s)
* your name <your_name@sangoma.com>
*
* This code is Sangoma Technologies Confidential Property.
* Use of and access to this code is covered by a previously executed
* non-disclosure agreement between Sangoma Technologies and the Recipient.
* This code is being supplied for evaluation purposes only and is not to be
* used for any other purpose.
*/
/**
* SNG Mariadbgalera service
*
* @author Santiago Tramoyeres Cuesta <scuesta@sangoma.com>
* @version
*/
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
safe_require_class('safe_service_class');

class Sng_mariadbgalera_service_class extends Safe_service_class{
	public function __construct($software,$name='mariadbgalera'){
		parent::__construct($software,$name);
	}
	public function depends_on(){
		$cluster_module = $this->node()->software()->application()->find_module_by_name('cluster');
		$clustermon_service = $this->node()->software()->application()->find_module_by_name('clustermon');
		if($cluster_module != NULL && $cluster_module->get_cluster_mode() !=='disabled'  && $this->status() !== Safe_service_class::STATUS_RUNNING && $clustermon_service->need_force_start()){
			return array(array('clustermon',true));
		}else{
			return array();
        }
	}
    /*
     * overwrite the base service start function for firewall, check if the script return error
     */
    public function api_start_service($obj_name=null, $params=null, &$output=null)
    {
        $rs = parent::api_start_service($obj_name, $params, $output);
        //wait for firewall start
        sleep(3);
        //check status
        $stats = $this->api_status_service($obj_name);
        if($stats){
            if( $stats['status'] == Safe_service_class::STATUS_RUNNING){
                return true;
            }else{
                $output = array($stats['status_text']);
            }
         }
        return false;
    }

}

