<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * SNG Troubleshooter service wrapper
 *
 * @author William Adam
 * @version
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
safe_require_class('service');
class Sng_troubleshooter_config_class extends Safe_configurable_object_class
{
    public function __construct($node, $parent_name)
    {
        // Parent constructor to invoke unserialize if needed
        parent::__construct($parent_name, "configuration", $node);
    }
    public function configure($modules)
    {
        foreach($modules as $module){
            if($module->troubleshooter_enabled()){
                $this->set_default_category($module->description());
                $module->troubleshooter_parameters($this);
            }
        }
        return parent::configure();
    }
}

class Sng_troubleshooter_service_class extends Safe_service_class
{
    public function __construct($software)
    {
        parent::__construct($software, 'troubleshooter');
    }
    /**
     * @brief
     *
     * @return
     */
    public function configure()
    {
        // Set the module description
        $this->set_description("Troubleshooter");
    
        // Create the config object
        $cfg = new Sng_troubleshooter_config_class($this->node(), $this->path() . '/' . $this->name());
        // Synch with DB
        $cfg->configure($this->node()->software()->application()->modules());
        $cfg->synch();
        // Attach config to module
        $this->set_config($cfg);

        return parent::configure();
    }
    public function can_restore($info, &$reason)
    {
        // Prevent calling parent as service status will be checked
        return true;
    }
    public function allow_user_ctl()
    {
        return true;
    }
    public function allow_dashboard()
    {
        return true;
    }
    /* Re-implement service like functions */
    // service control
    public function start(&$result = null)
    {
        return true;
    }
    public function stop(&$result = null)
    {
        return true;
    }
    private $_status=null;
    public function status(&$stats = null)
    {
        if(null===$this->_status || null !== $stats){
            $this->_status = Safe_service_class::STOPPED;
        }
        return $this->_status;

    }
    public function restart($force = false, &$result = null)
    {
        return true;
    }
    public function reload($force = false, &$result = null)
    {
        return true;
    }
    public function startup()
    {
        return false;
    }
    public function set_startup($mode)
    {
        return true;
    }
    public function stats()
    {
        $result = array();
        // Use process name
        return $result;
    }

}
/* End of file sng_troubleshooter_service_class.php */
