<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/* 
 * Dashboard
 *
 * Parameters:
 *     $system     = System data series 
 *                    ['cpu'] => CPU data series (pie)
 *                    ['memory'] => Memory data series (pie)
 *                    ['events'] => Events/hours data series (bar with 
 *                    info/warning/critical)
 *     $services   = Array of services data series
 *                   For each services
 *                     ['cpu'] => CPU data series (vertical bar)
 *                     ['memory'] => Memory data series (vertical bar)
 *                     ['events'] => Count of events for this service (just 
 *                     number)
 *     $curren_date = Current datetime in string format
 *     $hour_range = Hour range
*/
?>
<script type="text/javascript">

$(function() {

    var services = <?php echo $services;?>;

    displayServicesStatus(services);

});
</script>
<?php
if(!isset($service_container_width)){
    $service_container_width = 'half';
}

?>

    <div style='vertical-align: top;' class='safe_dashboard_container <?php echo $service_container_width;?>'>

<?php echo safe_webtabletitleopen("Services", '100%', 'sng_service_stats') ?>
  <thead>
    <th class="mytableheader" style="text-align: center;"></th>
    <th class="mytableheader" style="text-align: center;">Status</th>
    <th class="mytableheader" style="text-align: center;" width="25%">CPU</th>
    <th class="mytableheader" style="text-align: center;" width="25%">Memory</th>
<!--
    <th class="mytableheader" style="text-align: center;">Events</th>
    <th class="mytableheader" style="text-align: center;"></th>
    <th class="mytableheader" style="text-align: center;"></th>
-->
</thead>
<tbody id="sng_service_stats_table">
<?php foreach(json_decode($services, true) as $service):?>
<tr class='<?php echo (($i++)%2)?'odd':'even';?>'>
    <td style="text-wrap:none; white-space:nowrap;">
<!--
        <img src="/SAFe/images/silk/<?php echo $service['icon'];?>.png"/>
-->
    </td>
    <td style="text-wrap:none; white-space:nowrap;">
        <?php echo $service['name'];?>
    </td>
    <td width="30%">
        <div id="bar_cpu_<?php echo $service['module'];?>">
        <div id="bar_label_cpu_<?php echo $service['module'];?>" class="progress-label"></div>
        </div>
    </td>
    <td width="30%">
      <div id="bar_memory_<?php echo $service['module'];?>">
        <div id="bar_label_memory_<?php echo $service['module'];?>" class="progress-label"></div>
        </div>
    </td>
  </tr>
<?php endforeach; ?>
</tbody>
<?php echo safe_webtableclose() ?>
</div>
