<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2015  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * SNG Cluster Peer Access Key Class
 * @author Reza Samimi
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
safe_require_class('service');
safe_require_controller('sng','config_manager');
class Sng_cluster_config extends Sng_config_manager
{
    public function __construct()
    {
        parent::__construct();
        // $this->aggregate_object_view['_global']['modify'] = 'safe_tabs'; // 'safe_accordion';
    }
    public function index()
    {
        return $this->modify('cluster');
    }
    public function modify($module_name, $obj_type=null, $obj_name=null) {
        if ($obj_name) {
            $cluster_module = $this->_the_app->find_module_by_name('cluster');
            if ($cluster_module != NULL) {
                $peer_obj = $cluster_module->get_aggregate_object('peer', $obj_name);
                if ($peer_obj) {
                    $sngms_configuration = $peer_obj->get_aggregate_objects('sngms_configuration');
                    foreach ($sngms_configuration as $key=>$module) {
                       $mode = $module->ip_mode();
                    }
                    if ($mode != Sng_transcoding_config_class::HIDDEN_MODE) {
                        $this->hide_aggregate_object_list['sngms_module'] = true;
                        $this->hide_aggregate_object_list['sngms_device'] = true;
                    }
                }
            }
        }
        // Otherwise let config manager do its job
        if ($obj_type)
            $this->aggregate_object_view['_global']['modify'] = 'safe_tabs'; // 'safe_accordion';

        $res = parent::modify($module_name, $obj_type, $obj_name);
        return $res;
    }
    public function edit($module_name, $obj_type=null, $obj_name=null, $sub_type = null, $sub_name = null) {
        if ($sub_type == null && $obj_type == 'peer' && !isset($_POST['access-key'])) {
            return parent::modify('cluster');
        }
        else {
            return parent::edit($module_name, $obj_type, $obj_name, $sub_type, $sub_name);
        }
    }
    public function action_confirm($module_name, $action_name)
    {
        $cluster_module = $this->_the_app->find_module_by_name('cluster');
        $peer_node_type = $cluster_module->peer_node_type();
        if ($module_name == 'cluster' && $action_name == 'synchronize') {
            $data = array();
            $data['page_title'] = 'Not able to copy configuration to ' . $peer_node_type;
            $data['result'] = false;
            $data['action_url'] = base_url($this->router->fetch_class());
            $data['message_type'] = 'alert';
            $cluster_module = $this->_the_app->find_module_by_name('cluster');
            $network_service = $this->_the_app->find_module_by_name('network');
            if($cluster_module->check_peer_nodes_config($data) &&
               $cluster_module->check_ha_config($data)){
                $data['page_title'] = 'Copy configuration to ' . $peer_node_type;
                $data['message'] = 'Are you sure you want to copy configuration to ' . $peer_node_type . '?<br><br>';
                $data['message'] .= '<strong>All configuration on the peer node(s) will be replaced by the configuration currently stored on this node</strong>. ';
                $data['message'] .= 'Please be sure to copy configuration to ' . $peer_node_type. ' from the correct server before proceeding.<br><br>';
                $data['message'] .= '<strong>This operation may take several minutes.</strong>';
                $data['message_type'] = 'notice';
                $data['result'] = true;
                $data['action_url'] = base_url($this->router->fetch_class()). '/action/'. $module_name .'/' . $action_name;
                $data['setting']['title'] = 'Copying configuration to ' . $peer_node_type . '...';
                $data['setting']['sec'] = '300';
                $data['setting']['msg'] = 'Ooops ! Server timed out...';
                $data['setting']['label'] = 'Back';
                $data['setting']['url'] = base_url('sng_cluster_config');
            }
            echo json_encode($data);
        } else if ($module_name == 'cluster' && $action_name == 'reset_uuid') {
            $data['page_title'] = 'Reset UUID and Access Key';
            $data['message']  = 'Re-create local UUID and generate new Access Key data?<br><br>';
            $data['message'] .= '<strong>Associations from this node to any peer nodes will be lost and will have';
            $data['message'] .= ' to be re-configured using the newly-generated access key</strong>.<br><br>';
            $data['message'] .= '<strong>This operation will also overwrite the current cluster configuration on';
            $data['message'] .= ' disk with any unapplied changes.</strong><br><br>';
            $data['message'] .= 'Do you wish to proceed?';
            $data['message_type'] = 'alert';
            $data['result'] = true;
            $data['action_url'] = base_url($this->router->fetch_class()). '/action/'. $module_name .'/' . $action_name;
            $data['setting']['title'] = 'Re-generating local UUID, access keys and updating configuration...';
            $data['setting']['sec'] = '30';
            $data['setting']['msg'] = 'Ooops ! Server timed out...';
            $data['setting']['label'] = 'Back';
            $data['setting']['url'] = base_url('sng_cluster_config');
            echo json_encode($data);
        } else if ($module_name == 'cluster' && $action_name == 'local_key') {
            $data['page_title'] = 'Generate Access Key - Configuration Backup';
            $data['message'] = '<p>Before generating an access key, please create a backup.</p>';
            $data['message'] .= '<p>Are you sure you want to create a configuration backup?</p>';
            $data['message_type'] = 'notice';
            $data['result'] = true;
            $data['action_url'] = base_url($this->router->fetch_class()) . '/create_local_key/' . $module_name;
            $data['setting']['title'] = 'Generating the backup...';
            $data['setting']['sec'] = '60';
            $data['setting']['msg'] = 'Ooops ! Server timed out...';
            $data['setting']['label'] = 'Back';
            $data['setting']['url'] = base_url('sng_cluster_config');
            echo json_encode($data);
        } else {
            return parent::action_confirm($module_name, $action_name);
        }
    } 
    public function create_local_key($module_name, $obj_type="", $obj_name="")
    {
        $application_module = $this->_the_app->find_module_by_name('application');
        $output = array();
        $config_backup = $application_module->create_autoname_backup('configuration', 'ha_local_key_backup', $output);
        if($config_backup){
            return $this->_confirm($module_name, $obj_type, $obj_name, 'local_key');
        }else{
            return $this->_confirm($module_name, $obj_type, $obj_name, 'backup_failed', $output);
        }
    }
    private function _confirm($module_name, $obj_type, $obj_name, $action_name, &$output=null)
    { 
        $data = array();
        $cluster_module = $this->_the_app->find_module_by_name('cluster');
        if($action_name == 'local_key'){
            $data['page_title'] = 'Generate Access Key';
            $data['message'] = 'Are you sure you want to Generate Access Key?<br><br>';
            $data['message_type'] = 'notice';
            $data['result'] = true;
            $data['action_url'] = base_url($this->router->fetch_class()) . '/action/' . $module_name . '/' . $action_name;
            $data['setting']['title'] = 'Generating the access key...';
            $data['setting']['sec'] = '30';
            $data['setting']['msg'] = 'Ooops ! Server timed out...';
            $data['setting']['label'] = 'Back';
            $data['setting']['url'] = base_url('sng_cluster_config');
        }else if($action_name == 'backup_failed'){
            $data['page_title'] = 'Backup Failed';
            if(!isset($output)){
                $data['message'] = 'Failed creating configuration backup.';
            }else{
                $data['message'] = implode(' ', $output);
                if($cluster_module->no_peer_on_active_ha()){
                    $data['message'] = implode(' ', $output) . "<div>In order to complete the action, please stop Cluster Service and set HA Operational Mode to Disabled.</div>";
                }
            }
            $data['message_type'] = 'alert';
            $data['result'] = false;
        }
        echo json_encode($data);
    }
    public function backup_form($module_name, $obj_type, $reload=false, $obj_name=null, $sub_type=null)
    {
        $data = array();
        $data['page_title'] = 'Peer Nodes - Configuration Backup';
        $data['message'] = '<p>Before adding a peer node, please create a backup.</p>';
        $data['message'] .= '<p>Are you sure you want to create a configuration backup?</p>';
        $data['message_type'] = 'notice';
        $data['result'] = true;
        $data['action_url'] = base_url($this->router->fetch_class()) . '/create_peer/' . $module_name . '/' . $obj_type;
        $data['setting']['title'] = 'Generating the backup...';
        $data['setting']['sec'] = '60';
        $data['setting']['msg'] = 'Ooops ! Server timed out...';
        $data['setting']['label'] = 'Back';
        $data['setting']['url'] = base_url('sng_cluster_config');
        echo json_encode($data);
    }
    public function create_peer($module_name="", $obj_type="", $obj_name="")
    {
        $application_module = $this->_the_app->find_module_by_name('application');
        $output = array();
        $config_backup = $application_module->create_autoname_backup('configuration', 'add_peer_archive', $output);
        if($config_backup){
            $url = '/SAFe/' . $this->router->fetch_class() . '/add_form/' . $module_name . '/' . $obj_type;
            redirect($url, 'action');
        }else{
            return $this->_confirm($module_name, $obj_type, $obj_name, 'backup_failed', $output);
        }
    }
}
