<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * Network Config wrapper page
 * @author Santiago Tramoyeres Cuesta <scuesta@sangoma.com>
 *         
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
require_once ('application/controllers/Safe_CI_Controller.php');

class Sng_cps extends CI_Controller
{
    
    const REPORT_PATH = '/var/webconfig/reports/cps';
    public function __construct(){
        parent::__construct();        
    }

    public function index(){
        $this->cps();
    }

    public function exit_empty(){
        exit("[]");
    }

    private function getData($path){
        // safe_require_class('safe_semaphore_class');
        //        $sem = new Safe_semaphore_class($path);
        $output = array();
        $tries = 100;
        if(file_exists($path)){// && $sem->lock()){
            $output = (array) json_decode(file_get_contents($path),true);
        }else if(!file_exists($path))
            exit("File does not exists");

        // $sem->release();
        //unset($sem);
        return $output;
    }

    private function returnData(&$data){
        header('Content-Type:application/json');
        $content = @json_encode($data);
        if($content){
            $length = strlen($content);
            header('Content-Length: '.$length);
        }
        exit($content);
    }

    public function hourly(){
        if(WebAuthenticate(false))
            $this->returnData($this->getData(self::REPORT_PATH.'/hourly_report.json'));
        else
            $this->exit_empty();
    }

    public function weekly(){
        if(WebAuthenticate(false))
            $this->returnData($this->getData(self::REPORT_PATH.'/weekly_report.json'));
        else
            $this->exit_empty();
    }

    public function daily(){
        if(WebAuthenticate(false))
            $this->returnData($this->getData(self::REPORT_PATH.'/daily_report.json'));
        else
            $this->exit_empty();
    }
    
    public function update(){
        if(WebAuthenticate(false))
            $this->returnData($this->getData(self::REPORT_PATH.'/nts_info.json'));
        else
            $this->exit_empty();
    }

    public function cps(){
        SAFE_WC_AUTHENTICATE();
        // Set the basic data
        /* $data['page_summary'] = 'This page displays detailed information about the product components.'; */
        /* $data['page_large_icon'] = '/images/icons/32x32/icon-register.png'; */
        /* $data['page_small_icon'] = '/images/icons/16x16/icon-register.png'; */

        /* $this->load->view('safe_header',$data); */
        $this->load->view('sng_cps_open',$data);
        $this->load->view('sng_cps_hourly',$data);
        $this->load->view('sng_cps_close',$data);
        /* $this->load->view('safe_footer',$data); */
    }

}

?>