<?php
/** vim: set tabstop=4 softtabstop=4 shiftwidth=4 textwidth=80 smarttab expandtab: **/
/** coding: utf-8: **/
/*
 * Copyright (C) 2012  Sangoma Technologies Corp.
 * All Rights Reserved.
 *
 * Author(s)
 * your name <your_name@sangoma.com>
 *
 * This code is Sangoma Technologies Confidential Property.
 * Use of and access to this code is covered by a previously executed
 * non-disclosure agreement between Sangoma Technologies and the Recipient.
 * This code is being supplied for evaluation purposes only and is not to be
 * used for any other purpose.
*/
/**
 * Network Config wrapper page
 * @author William Adam <william.adam@sangoma.com>
 *         
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once ('application/helpers/safe_helper.php');
safe_require_controller('sng','config_manager');
class Sng_network_config extends Sng_config_manager
{
    public function __construct()
    {
        parent::__construct();
        $this->aggregate_object_view['_global']['modify'] = 'safe_tabs';
    }
    public function index()
    {
        return $this->modify('network');
    }
    public function up($module_name, $obj_type, $obj_name)
    {
        $this->_action($module_name, $obj_type, $obj_name, 'up');
    }
    public function down($module_name, $obj_type, $obj_name)
    {
        $this->_action($module_name, $obj_type, $obj_name, 'down');
    }
    public function up_confirm($module_name, $obj_type, $obj_name)
    {
        return $this->_confirm($module_name, $obj_type, $obj_name, 'up');
    }
    public function down_confirm($module_name, $obj_type, $obj_name)
    {
        return $this->_confirm($module_name, $obj_type, $obj_name, 'down');
    }
    private function _confirm($module_name, $obj_type, $obj_name, $action_name)
    {
        if (!isset($module_name)) {
            $data['message'] = 'Module name required!';
            $data['message_type'] = 'alert';
            $data['result'] = false;
            echo json_encode($data);
            exit();
        }
        // Retrieve module to work on
        $module = $this->_the_app->find_module_by_name($module_name);
        $aggr_object = $module->api_retrieve_interface($obj_name);
        $description = $module->description();
        // Set the basic data
        $data['page_title'] = ucwords($module->description()) . ' : Set interface';
        if (isset($aggr_object)) {
            //Check to make sure you can delete, then delete the object
            $reason = array();
            $action_description = 'set interface ' . $aggr_object->interface_name() . ' ' . $action_name;
            $data['message'] = 'Are you sure you want to ' . $action_description . '?';
            $data['message_type'] = 'notice';
            $data['result'] = true;
            $data['action_url'] = base_url($this->router->fetch_class()). '/' .$action_name. '/'. $module_name .'/' . $obj_type . '/' . $obj_name;
            $data['setting']['title'] = 'Processing ' . $action_description;
            $data['setting']['sec'] = '60';
            $data['setting']['msg'] = 'Ooops ! '. $action_description . ' time out...';
            $data['setting']['label'] = 'Close';
            $data['setting']['url'] = base_url($this->router->fetch_class());
            echo json_encode($data);
        }else{
            $data['message'] = 'Interface not found!';
            $data['message_type'] = 'alert';
            $data['result'] = false;
            echo json_encode($data);
        }
    }
    private function _action($module_name, $obj_type, $obj_name, $action_name)
    {
        if (!isset($module_name)) {
            $data['message'] = 'Module name required!';
            $data['message_type'] = 'alert';
            $data['result'] = false;
            echo json_encode($data);
            exit();
        }
        // Retrieve module to work on
        $module = $this->_the_app->find_module_by_name($module_name);
        $aggr_object = $module->api_retrieve_interface($obj_name);
        $description = $module->description();
        
        // Set the basic data
        $action_description = 'set interface ' . $obj_name . ' ' . $action_name;
        $data['page_title'] = ucwords($module->description()) . ' : Set interface';
        if (isset($aggr_object)) {
            $output = array();
            if($action_name == 'down'){
                $rc = $module->api_down_interface($obj_name, null, $output);
            }else{
                $rc = $module->api_up_interface($obj_name, null, $output);
            }
            if($rc){
                //return redirect url
                $data['result'] = true;
                $data['redirect_url'] =  base_url($this->router->fetch_class());
            }else{
                $data['result'] = false;
                $data['message'] = $output['message'];
                $data['message_type'] = 'alert';
            }
            echo json_encode($data);
        }else{
            //return error message
            $data['message'] = 'Object not found!';
            $data['message_type'] = 'alert';
            $data['result'] = false;
            echo json_encode($data);
        }
    }
}
