<?php
/*
	NSG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.

	Licence information can be found within the file LICENCE.php

	The Original Code is NSG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

require_once("../../gui/Webconfig.inc.php");
require_once("../../gui/Charts.inc.php");
require_once("../../api/File.class.php");
require_once("../../api/ShellExec.class.php");
require_once(GlobalGetLanguageTemplate(__FILE__));
require_once("../include/SngProduct.class.php");
///////////////////////////////////////////////////////////////////////////////
//
// Variables
//
///////////////////////////////////////////////////////////////////////////////
$new_eth = false;
$new_tdm = false;
$display_eth = false;
$display_tdm = false;
$stop_eth = false;
$stop_tdm = false;
$no_warn = false;
$fail_eth = false;
$fail_tdm = false;
$data = date('Y-m-d-H:m');

// date() returns UTC timezone and doens't honor the defaulttimezone set in ntp module, probably because this page
// is part of clearos and somehow doesn't work with api ntp module. so as a workaround, php DateTime() object is used
$systemtimezone="UTC";
exec("/usr/local/nsc/bin/pcregrep -o1 '^ZONE=[\"]\K([^\"]+)' /etc/sysconfig/clock", $zone);
if (count($zone) > 0) $systemtimezone = $zone[0];
$date = new DateTime(null, new DateTimeZone($systemtimezone));
$capture_dt = $date->format('Y-m-d-H-i-s');
$capture_dir = '/var/log/tmp/webpcap';
$merged_file_name = $capture_dir . "/prot-capture-" . $capture_dt . ".pcap";

///////////////////////////////////////////////////////////////////////////////
//
// Main
//
///////////////////////////////////////////////////////////////////////////////
WebAuthenticate();


find_procs($process, $tdm_process);
$stop_all = false;
if (isset($_POST['stop_eth_capture']) && $_POST['stop_eth_capture']) {
	//Stop the tcpdump service
	shell_exec ('sudo /bin/kill ' . $process);
	sleep(2);
	if (trim($process) != "")
    	shell_exec('sudo /bin/kill -9 tcpdump');

	find_procs($process,$tdm_process);
	$stop_eth = true;
}
elseif (isset($_POST['stop_tdm_capture']) && $_POST['stop_tdm_capture']) {
	//Stop Wanpipemon service
	shell_exec ('sudo /bin/kill -2 ' . $tdm_process);
	sleep(2);
	if (trim($tdm_process) != "")
		shell_exec('sudo /bin/kill -9 wanpipemon');

	find_procs($process,$tdm_process);
	$stop_tdm = true;
}
elseif (isset($_POST['stop_both_capture']) && $_POST['stop_both_capture']) {
	//Stop the tcpdump service
	$stop_eth=true;
	shell_exec ('sudo /bin/kill ' . $process);
	sleep(2);
	if (trim($process) != "")
    	shell_exec('sudo /bin/kill -9 ' . $process);

	//Stop wanpipemon service
	$stop_tdm = true;
	shell_exec ('sudo /bin/kill -2 ' . $tdm_process);
	sleep(2);
	if (trim($tdm_process) != "")
		shell_exec('sudo /bin/kill -9 ' . $tdm_process);

	find_procs($process, $tdm_process);
	$stop_all = true;
}
elseif (isset($_POST['capture-eth']) && $_POST['capture-eth'] && empty($process)) {
  //Validate filter field for illegal characters
	if (validate('eth') ) {
    //Check if interface running
    if ($_POST['interface'] != "any")
  		system ('sudo /sbin/ifconfig ' . $_POST['interface'] . ' | grep RUNNING >> /dev/null', $retCode);
    else
      	$retCode=0;

  	$max_size = isset($_POST['max_size']) ? $_POST['max_size'] : 1000;

		if ($retCode == 0) {
			$display_eth=true;
			$new_eth = true;

      // make sure the /var/log/tmp/webpcap exists before proceeding
      shell_exec("sudo /bin/mkdir -p /var/log/tmp/webpcap");

      shell_exec ("sudo /bin/rm -fr /var/log/tmp/webpcap/prot-capture*");
      //add option -B to increase the buffer size to 4MB
      //add option -C 100 -W 10 to limit capture size to 10 * 100 MB files.
      // option -Z is required with -C to force running dump as root or else we'll get: prot-capture.pcap0: Permission denied
      $cmd = "nice sudo /usr/sbin/tcpdump -B 4096 -C 100 -W " . $max_size . " -Z root -w /var/log/tmp/webpcap/prot-capture.pcap -s 0 -ni ".$_POST['interface'];

    if ($_POST['filter'] == ".*" || $_POST['filter'] == "")
	$cmd .= " >> /dev/null &";
    else
	$cmd = escapeshellcmd($cmd . " " . urldecode($_POST['filter']));
	// took the following out of escape method to avoid '>>' being escaped to '\>\>'
	$cmd .= " >> /dev/null &";

    passthru ($cmd, $retCode);
    sleep(4);
	}
		else
			$fail_eth = true;

		find_procs($process,$tdm_process);
	}
}
elseif (isset($_POST['capture-tdm']) && empty($tdm_process)) {
	//Validate filter field for illegal characters
	if (validate('tdm') ) {
		//Check if interface running
		system ('sudo /sbin/ifconfig ' . $_POST['interface'] . ' | grep RUNNING >> /dev/null', $retCode);

		if ($retCode == 0) {
			$display_tdm=true;
			$new_tdm = true;
			shell_exec ("sudo /bin/rm -fr /tmp/prot-tdm-capture.pcap");

			$cmd = "nice sudo /usr/sbin/wanpipemon -i " . $_POST['interface'] . " -pcap -pcap_file /tmp/prot-tdm-capture.pcap -prot MTP2" ;

			if ($_POST['msu'])
				$cmd.= " -mtp2-msu";

			$cmd.= "  -full -systime -noexit";

			if ($_POST['transmit'] == 'tx')
				$cmd.= " -tx";
			if ($_POST['transmit'] == 'rx')
				$cmd.= " -rx";
			if ($_POST['diff'])
				$cmd.= " -diff";

      if ($_POST['raw'])
        $cmd .= ' -c tr >> /dev/null &';
      else
  			$cmd.= " -c trd >> /dev/null &";

			passthru ($cmd, $retCode);

			sleep(5);
		}
		else
			$fail_tdm = true;

		find_procs($process,$tdm_process);
	}
}
elseif (isset($_POST['flush_all'] ) && $_POST['flush_all']) {
	shell_exec("cd /var/log/tmp/webpcap && sudo rm -fr prot-capture*");
}
elseif (isset($_POST['download_eth']) && $_POST['download_eth']) {
	$stop_eth = true;

        merge_rotated_files($merged_file_name, $capture_dir);
    header("Content-Disposition: attachment; filename=\"".basename($merged_file_name)."\";" );
    header("Content-Transfer-Encoding: binary");
    header("Content-Length: ".filesize($merged_file_name));
    header("Content-Type: application/octet-stream");
    readfile($merged_file_name);

    shell_exec ("sudo rm -fr ". $merged_file_name);
}
elseif (isset( $_POST['download_tdm']) && $_POST['download_tdm']) {
	$stop_tdm = true;
	$filename = '/tmp/prot-tdm-capture.pcap';
	shell_exec ("sudo cp /tmp/prot-tdm-capture.pcap .");
	header("Content-Disposition: attachment; filename=\"".basename("prot-tdm-capture.pcap")."\";" );
	header("Content-Transfer-Encoding: binary");
 	header("Content-Length: ".filesize("prot-tdm-capture.pcap"));
	header("Content-Type: application/octet-stream");
	readfile("prot-tdm-capture.pcap");

	shell_exec ("sudo rm -fr prot-tdm-capture.pcap");
}
elseif (isset($_POST['download_merge']) && $_POST['download_merge']) {
	$stop_tdm = true;
	$stop_eth = true;
	$filename = '/var/log/tmp/webpcap/prot-capture.zip';
	//create archive
	shell_exec ('sudo /usr/bin/zip /var/log/tmp/webpcap/prot-capture.zip /var/log/tmp/webpcap/prot-capture.pcap /tmp/prot-tdm-capture.pcap');
	shell_exec ("sudo cp /var/log/tmp/webpcap/prot-capture.zip .");
	header("Content-Disposition: attachment; filename=\"".basename("prot-capture.zip")."\";" );
	header("Content-Transfer-Encoding: binary");
	header("Content-Length: ".filesize("prot-capture.zip"));
	header("Content-Type: application/octet-stream");
	readfile("prot-capture.zip");

	shell_exec ("sudo rm -fr prot-capture.zip");
}
else {
	$files = glob('/var/log/tmp/webpcap/*.pcap*');
	$stop_eth = (count($files) > 0) ? true : false;
}

$layout = isset($_GET['layout'])? $_GET['layout'] : 'default';
WebHeader(WEB_LANG_PAGE_TITLE,$layout);
if($layout=='default')
    WebDialogIntro(WEB_LANG_PAGE_TITLE, "/images/icon-diskusage.png", WEB_LANG_PAGE_INTRO);
unset($tdm);
unset($eth);
unset($all);

if ((trim($process) != "" && $new_eth) || (trim($tdm_process) != "" && $new_tdm)){
	if ($display_eth || $display_tdm) {
		if ($display_eth && $new_eth)
			$eth = '<li>To stop the Ethernet capture, please click <input type="submit" name="stop_eth_capture" value="Stop" class="ui-state-default ui-corner-all" /></li>';

		if ($display_tdm && $new_tdm)
			$tdm = '<li>To stop the TDM capture, please click <input type="submit" name="stop_tdm_capture" value="Stop" class="ui-state-default ui-corner-all" /></li>';

		if (trim($process) != "" && trim($tdm_process) != "") {
			$all = '<li>To stop both captures, please click <input type="submit" name="stop_both_capture" value="Stop All Captures" class="ui-state-default ui-corner-all" /></li>';
			$no_warn = true;
		}
		echo "<form method='post'>";
		WebDialogInfo('<ul><li>Protocol Capture started. </li>'.$eth.$tdm.$all.'</ul>');
		echo "</form>";
	}
}

unset($tdm);
unset($eth);
unset($all);

if ((trim($process) != "" && !$new_eth) || (trim($tdm_process) != "" && !$new_tdm)) {
	//Process currently running please stop
	$stop_eth = false;
	if (trim($process) != "" && !$new_eth) {
		$eth = '<li>Please stop the Ethernet capture by clicking <input type="submit" name="stop_eth_capture" value="Stop" class="ui-state-default ui-corner-all" /></li>';
		$display_eth=true;
	}
	if (trim($tdm_process) != "" && !$new_tdm) {
		$tdm = '<li>Please stop the TDM capture by clicking <input type="submit" name="stop_tdm_capture" value="Stop" class="ui-state-default ui-corner-all" /></li>';
		$display_tdm=true;
	}

	if (trim($process) != "" && trim($tdm_process) != "" && !$no_warn) {
		$all = '<li>To stop the TDM and Ethernet captures, click <input type="submit" name="stop_both_capture" value="Stop All Captures" class="ui-state-default ui-corner-all" /></li>';
		$display_tdm=true;
		$display_eth = true;
	}
	echo "<form method='post'>";
	WebDialogWarning('<ul><li>There is already a protocol capture running.</li>'.$eth .$tdm .$all .'</ul>');
	echo "</form>";
}

if ($fail_eth || $fail_tdm) {
  if ($_POST['interface'] == "any")
    $int = "All Interfaces";
  else
    $int = $_POST['interface'];

	if ($fail_eth) {
    if ($_POST['interface'] == "any")
      $eth_error = "<li>Unable to start protocol capture on <b>ALL</b> Ethernet Devices</li>";
    else
      $eth_error = "<li>Unable to start protocol capture on Ethernet Device <b>" . $int . "</b></li>";
  }
	if ($fail_tdm)
		$tdm_error = "<li>Unable to start protocol capture on TDM Device <b>" . $int . "</b></li>";
	WebDialogWarning('<ul>'.$eth_error .$tdm_error .'<li>Device is not currently running</li>'.'</ul>');
}

unset($tdm);
unset($eth);
unset($all);
unset($flush);

if ($stop_eth || $stop_tdm || $stop_all) {
	if ($stop_eth) {
		$eth = '<li>To download the Ethernet capture, please click <input type="submit" name="download_eth" value="Download" class="ui-state-default ui-corner-all" /></li>';
		$flush = '<br /><li>To flush all existing captures, please click <input type="submit" name="flush_all" value="Flush All Captures" class="ui-state-default ui-corner-all" /></li>';
		$display_eth = false;
	}
	if ($stop_tdm) {
		$tdm = '<li>To download the TDM capture, please click <input type="submit" name="download_tdm" value="Download" class="ui-state-default ui-corner-all" /></li>';
		$display_tdm = false;
	}
	if ($stop_all) {
		$display_tdm = false;
		$display_eth = false;
		$all = '<li>To download both Ethernet and TDM captures, please click <input type="submit" name="download_merge" value="Download" class="ui-state-default ui-corner-all" /></li>';
	}
	echo "<form method='post'>";
	WebDialogInfo('	<ul><li>Protocol Capture stopped successfully.</li>'.$eth.$tdm.$all.$flush.'</ul>');
	echo "</form>";
}

capture_info($display_eth);
//capture_wanpipe_info($display_tdm);
WebFooter($layout);

echo "<script>
		$('#frame_network_capture').on('load', function () {
			if (window.location != window.parent.location) {
				iframe = $('body').parent()[0];
			    $(iframe).find('#safe_header').remove();
			    $(iframe).find('#safe_left_menu').remove();
			    $(iframe).find('#safe_breadcrumb').remove();
			    $(iframe).find('#safe_footer').remove();
			    $(iframe).find('#safe_content').css('margin-top', '0px')
			    $(iframe).find('#safe_content').css('margin-left', '0px');
			    $($(iframe).find('input[name=capture-eth]')[0]).on('click', function() {
			    	safe_wait();
				});
			    $($(iframe).find('input[name=stop_eth_capture]')[0]).on('click', function() {
			    	safe_wait();
				});
			}
		})
	</script>
";
///////////////////////////////////////////////////////////////////////////////
//
// Functions
//
///////////////////////////////////////////////////////////////////////////////
function merge_rotated_files($merged_file_name, $dir) {
	$files = array();
	$all_files = scandir($dir);
	foreach ($all_files as $k=>$v) {
		if ($v !== '.' && $v !== '..' && strpos($v, '.pcap')) {
			array_push($files, $dir . "/" . $v);
		}
	}
	$file_str = implode(" ", $files);
	if (!empty($file_str)) {
		shell_exec("sudo mergecap -w " . $merged_file_name . " " . $file_str);
	}
}

function capture_info($stop = false) {
	$pick = get_last_entry();

	echo "<form method='post' enctype='application/x-www-form-urlencoded'>";

	WebFormOpen($_SERVER['PHP_SELF']);
	WebTableOpen('Network Packet Capture Parameters');
	echo "<tr>";
	echo "<td width='37%' class='mytablesubheader'>Network Interface</td>";
	echo "<td>";

	//Ethernet Interface Drop Down
	$interfaces = get_interfaces();

  echo "<select name='interface' id='interface'>";
  echo "<option value='any'>All Interfaces</option>";
	if (!empty($interfaces)) {
		foreach ($interfaces as $k=>$v) {
			echo "<option value='" . $k . "' >" . $v . "</option>";
		}
	}
	echo "</select>";
	echo "</td>";
	echo "</tr>";
	echo "<tr>";
	$pick['filter'] = isset($pick['filter'])? $pick['filter']: '';
	echo "<td width='37%' class='mytablesubheader' >Filter(s)</td>";
	echo "<td><input type='text' name='filter' value='" . $pick['filter']. "' /></td>";
	echo "<td></td>";
	echo "</tr>";

	echo "<tr>";
	echo "<td width='37%' class='mytablesubheader' >Maximum File Size (MB)</td>";
	echo "<td><select name='max_size' id='max_size'>";
	echo "<option value='5'>500 MB</option>";
	echo "<option value='10' selected='selected'>1000 MB</option>";
	echo "<option value='15'>1500 MB</option>";
	echo "<option value='20'>2000 MB</option>";
	echo "</select></td>";
	echo "</tr>";

	echo "<tr>";
	echo "<td colspan='2' width='100%' class='mytablelegend'>";
	if (!$stop)
		echo "<input type='submit' name='capture-eth' value='Capture' class='ui-state-default ui-corner-all' />";
	else
		echo "<input type='submit' name='capture-eth' value='Capture' class='ui-state-default ui-corner-all' style=\"color:#C0C0C0\" disabled='disabled' />";
	echo "</td>";
	echo "</tr>";
	WebTableClose();
	WebFormClose();

	echo "</form>";
}

function capture_wanpipe_info($stop = false) {

	$pick = get_last_entry();
	exec ("/usr/sbin/wanrouter status | grep -c wanpipe", $output);

	if ($output[0] == 0)
		$wanpipe=false;
	else
		$wanpipe=true;

	echo "<form method='post'>";

	WebFormOpen($_SERVER['PHP_SELF']);
  WebTableOpen('TDM Packet Capture Parameters');
	if ($wanpipe) {
		echo "<tr>";
		echo "<td width='37%' class='mytablesubheader'>TDM Interface</td>";
		echo "<td>";

		//Ethernet Interface Drop Down
		$interfaces = get_wanpipe_interfaces();

		echo "<select name='interface' id='interface'>";
		if (!empty($interfaces)) {
			foreach ($interfaces as $k=>$v) {
				echo "<option value='" . $k . "' >" . $v . "</option>";
			}
		}
		echo "</select>";
		echo "</td>";
		echo "</tr>";
		echo "<tr>";
		echo "<td width='37%' class='mytablesubheader' >Filter(s)</td>";
		echo "<td>";
		echo "<table>";
		echo "<tr>";
		echo "<td rowspan='2'>";
		echo "<input type='radio' name='transmit' value='tx' />TX Only<br />";
		echo "<input type='radio' name='transmit' value='rx' />RX Only<br />";
		echo "</td>";
		echo "<td>";
		echo "<input type='checkbox' name='diff' />Only capture different frames<br />";
		echo "<input type='checkbox' name='msu' />Capture only SS7 MSU's<br />";
	    echo "<input type='checkbox' name='raw' />Capture RAW Trace<br />";
	    echo "</td>";
		echo "</tr>";
		echo "</table>";
		echo "<td></td>";
		echo "</tr>";
		echo "<tr>";
		echo "<td colspan='2' class='mytablelegend'></td>";
		if (!$stop)
			echo "<input type='submit' name='capture-tdm' value='Capture' class='ui-state-default ui-corner-all' />";
		else
			echo "<input type='submit' name='capture-tdm' value='Capture' class='ui-state-default ui-corner-all' style=\"color:#C0C0C0\" disabled='disabled' />";
		echo "</td>";
		echo "</tr>";
	}
	elseif (!$wanpipe) {
		echo "<tr>";
		echo "<td><b><font color='red'>THERE ARE CURRENTLY NO TDM DEVICES RUNNING. PLEASE START THE GATEWAY TO RUN A TDM CAPTURE</font></b></td>";
		echo "</tr>";
	}
	WebTableClose();
	WebFormClose();

	echo "</form>";
}



/**
Returns an array of ethernet interfaces
*/
function get_interfaces() {

    $cmd = "sudo /sbin/ifconfig -a | grep 'eth\|sngdsp' | cut -d: -f1 | awk '{ print $1}'";
    exec($cmd,$result);

    if (!empty($result)) {
	foreach ($result as $interface) {
	    $status = check_interface($interface);
	    if ($status == 'up')
		$array[$interface] = $interface;
	}
    }

    return $array;
}

function get_wanpipe_interfaces() {
	$cmd = "sudo /sbin/ifconfig -a | grep w.g. | cut -d: -f1 | awk '{ print $1}'";
	exec ($cmd,$result);

	if (!empty($result)) {
		foreach ($result as $interface) {
			$array[$interface] = $interface;
		}
	}

	return $array;
}

function get_last_entry() {
	$pick = array();
	if (isset($_POST['filter']) && $_POST['filter'] != "")
		$pick['filter'] = $_POST['filter'];
	elseif (isset($_POST['filter']) && $_POST['filter'] == "")
		$pick['filter'] = ".*";

	return $pick;
}

function validate($type) {
  if ($type == "any")
    return true;
  elseif ($type == "eth") {
		if ($_POST['filter'] == ".*") {
			return true;
		}
		else {
      //return !preg_match('/[^A-Za-z0-9.#\\-$]/', $_POST['filter']);
      return true;
		}
	}
	if ($type == "tdm") {
		return true;
	}
}

function find_procs(&$process = null, &$tdm_process = null) {
	passthru('pidof tcpdump > /tmp/eth-proc.txt');
	$process = file_get_contents('/tmp/eth-proc.txt');
	shell_exec ('rm -fr /tmp/eth-proc.txt');
	passthru ('pidof wanpipemon > /tmp/tdm-proc.txt');
	$tdm_process = file_get_contents('/tmp/tdm-proc.txt');
	shell_exec ('rm -fr /tmp/tdm-proc.txt');
}

// This function is temporary workaround and we should use
// the API Sng_network_service_class.api_status_interface() once we re-write this code
function check_interface($interface) {
    $target = "/sys/class/net/" . $interface . "/operstate";
    $file = fopen($target, "r");

    if (!$file) return 'down';
    $status = fread($file, filesize($target));
    fclose($file);
    return trim($status);
}

?>
