<?php
// DEBUG info
$m_time = explode(" ",microtime());
$m_time = $m_time[0] + $m_time[1];
$GLOBALS['sng_loadstart'] = $m_time;

///////////////////////////////////////////////////////////////////////////////
// Menu handling
///////////////////////////////////////////////////////////////////////////////
$debug =(file_exists("/usr/local/sng/conf/sng_dev_env"));

// Build menu
//-----------

$menu_pages = WebMenuFetch();
$highlight = array();

// Pick out the current pages section and subsection for menu highlighting
foreach ($menu_pages as $pageinfo) {
  // FIXME: branding hack
  $pageinfo['section'] = preg_replace("/ClearCenter/", "Sangoma", $pageinfo['section']);

  // wadam - Find longest url match in request_uri to catch MVC url
  if(!strncmp($pageinfo['url'], $_SERVER['REQUEST_URI'], strlen($pageinfo['url']))) {
    // Check already matched ?
    if(empty($highlight) || strlen($pageinfo['url'])>$highlight['match']){
      $highlight['page'] = $pageinfo['url'];
      $highlight['section'] = $pageinfo['section'];
      $highlight['subsection'] = $pageinfo['section'] . $pageinfo['subsection'];
      $highlight['match'] = strlen($pageinfo['url']);
    }
  }
}

$safe_menu = array();
foreach($menu_pages as $page){
  // Filter out pages if needed
  if(!$debug && $page['type'] === 'debug')
    continue;
  $safe_menu[$page['section']][$page['subsection']][$page['title']] = array(
    'url' => $page['url'],
  );
}
$safe_menu_html = "<ul class='safe_menu_container'>";
// TODO::PHP7 Upgrade. Hide non working pages. Please remove after fix
//unset($safe_menu["System"]["Monitoring"]["SNMP"]);
 foreach($safe_menu as $section => $section_data){
  $safe_menu_html .= "<li class='safe_menu_section' onclick='onMenuClick(event,this);'>";
  $safe_menu_html .= "<div class='safe_menu_section_label";
  if(isset($highlight['section']) && $highlight['section'] == $section){
    $safe_menu_html .= " safe_menu_selected";
  }
  $safe_menu_html .= "'>";
  if(isset($highlight['section']) && $highlight['section'] == $section){
    $safe_menu_html .= "<i class='fa fa-chevron-down'></i> &nbsp;";
  }else{
    $safe_menu_html .= "<i class='fa fa-chevron-right'></i> &nbsp;";
  }
  $safe_menu_html .= $section."</div>";
  $safe_menu_html .= "<ul class='safe_menu' style='";
  if(isset($highlight['section']) && $highlight['section'] == $section){
    $safe_menu_html .= "display:block;";
  }else{
    $safe_menu_html .= "display:none;";
  }
  $safe_menu_html .= "'>";
  foreach($section_data as $subsection => $subsection_data){
    $safe_menu_html .= "<li class='safe_menu_subsection' onclick='onMenuClick(event, this);'>";
    $safe_menu_html .= $subsection;
    $safe_menu_html .= "<ul class='safe_menu'>";
    foreach($subsection_data as $entry => $entry_def){
      $extra = "";
      if(1 == preg_match('/^http/', $entry_def['url'])) {
        $extra = " target='_blank' ";
      }

      $safe_menu_html .= "<a href='".$entry_def['url']."' ".$extra.">";
      $safe_menu_html .= "<li class='safe_menu_entry'>";
      $safe_menu_html .= "<i class='fa fa-caret-right'></i> &nbsp;";
      $safe_menu_html .= $entry;
      $safe_menu_html .= "</li>";
      $safe_menu_html .= "</a>";
    }
    $safe_menu_html .= "</ul>";

    $safe_menu_html .= "</li>";
  }
  $safe_menu_html .= "</ul>";

  $safe_menu_html .= "</li>";
}
$safe_menu_html .= '</ul>';

///////////////////////////////////////////////////////////////////////////////
// Main
///////////////////////////////////////////////////////////////////////////////
$user_name =isset($_SESSION['user_name'])?$_SESSION['user_name']:$_SESSION['user_login'];

//$safe_product_version = "X.Y.Z (W)";
$safe_product_version = file_get_contents("/etc/release-version");
if(FALSE !== $safe_product_version){
  $safe_product_version = "Version: ".trim($safe_product_version);
}


$safe_top_menu_url['events'] = "/SAFe/sng_dashboard/events";
$safe_top_menu_url['configuration'] = "/SAFe/sng_config_manager";
$safe_top_menu_url['application'] = "/SAFe/sng_control_panel";
$safe_top_menu_url['system'] = "/SAFe/sng_dashboard";
$safe_top_menu_url['network'] = "/SAFe/sng_network_config";
$safe_top_menu_url['storage'] = "/SAFe/sng_storage_status";
$safe_top_menu_url['update'] = "/SAFe/sng_update_manager_alias";
$safe_top_menu_url['troubleshooter'] = "";
$safe_header = "
<!-- Body -->
<body>
<div id='safe_body'>
<div id='dialog_network_capture' title='Create new user' style='min-height:300px;overflow:hidden;display: none;'>
    <div id='frame_wait_message' style='width:100%;height:100%;'>
      <center'><br /> <br /><img src='/templates/base/images/icons/16x16/icon-loading.gif' style='vertical-align:middle;'> &nbsp;Please wait...</center>
    </div>
    <iframe id='frame_network_capture' src='/admin/sng_capture.php?layout=frame' scrolling='no' style='width:100%;height:100%;border:0px'></iframe>
</div>

<!-- TOP bar -->
<div id='safe_header'>
  <div id='safe_top_left'>
    <div id='safe_logo'>
        <img src='/SAFe/load/templates/sng/images/logo.png'/>
    </div>
    <div id='safe_version' class='ellipsis'>$safe_product_version</div>
  </div>
  <div id='safe_top_bar'>
    <ul class='safe_top_menu'>
    <!-- Troubleshooter process status
        Default is hidden, to activate:
        $('#troubleshooter_status').addClass('safe_pulse');
      or
        $('#troubleshooter_status').addClass('safe_blink');

      to stop, remove above classes (using removeClasss) and add safe_hide again
        so top container disappear from bar
    -->
      <li>
        <div id='troubleshooter_status' class='safe_dialog_container safe_hide'>
          <a href='".$safe_top_menu_url['troubleshooter']."'>
            <div class='safe_dropdown_arrow_up'></div>
            <div class='safe_top_menu_label safe_warning'>
              <span><i class='fa fa-bug fa-2x'></i></span>
              <span class='ellipsis safe_top_menu_label_text'>Troubleshooting</span>
            </div>
          </a>
        </div>
        <div id='troubleshooter_status_details' class='safe_dialog ui-widget' style='width:150px;'>
          <table class='safe_stats_table'>
          </table>
        </div>
      </li>
      <li>
        <div class='safe_dialog_container'>
            <div class='safe_dropdown_arrow_up'></div>
            <div id='network_capture' class='safe_top_menu_label'>
              <span><i class='fa fa-bar-chart-o fa-2x'></i></span>
              <span class='ellipsis safe_top_menu_label_text'>Network Capture</span>
            </div>
        </div>
        <div id='network_capture' class='safe_dropdown ui-widget'>
        </div>
      </li>
    <!-- System status -->
      <li>
        <div class='safe_dialog_container'>
          <a href='".$safe_top_menu_url['system']."'>
            <div class='safe_dropdown_arrow_up'></div>
            <div id='sytem_status' class='safe_top_menu_label'>
              <span><i class='fa fa-tachometer fa-2x'></i></span>
              <span class='ellipsis safe_top_menu_label_text'>System</span>
            </div>
          </a>
        </div>
        <div id='system_status_details' class='safe_dialog ui-widget' style='width:250px;'>
          <div id='system_cpu_details' style='float:left; width:50%;'>
            <p class='safe_stats_table_title'>CPU</p>
            <div id='top_plot_pie_system_cpu' class='safe_top_menu_plot'>
            </div>
          </div>
          <div id='system_memory_details' style='float:left; width:50%;'>
            <p class='safe_stats_table_title'>Memory</p>
            <div id='top_plot_pie_system_memory' class='safe_top_menu_plot'>
            </div>
          </div>
        </div>
      </li>
      <!-- Network status -->
      <li>
        <a href='".$safe_top_menu_url['network']."'>
          <div class='safe_dialog_container'>
              <div class='safe_dropdown_arrow_up'></div>
              <div id='network_status' class='safe_top_menu_label'>
                <span><i class='fa fa-sitemap fa-2x'></i></span>
                <span class='ellipsis safe_top_menu_label_text'>Network</span>
              </div>
          </div>
          <div id='network_status_details' class='safe_dialog ui-widget'
          style='min-width: 200px;'>
              <!-- <p class='safe_stats_table_title'>Network Interfaces</p>-->
              <table class='safe_stats_table'>
              </table>
          </div>
          </a>
      </li>
      <!-- Storage status -->
      <li>
        <div class='safe_dialog_container'>
          <a href='".$safe_top_menu_url['storage']."'>
            <div class='safe_dropdown_arrow_up'></div>
            <div id='storage_status' class='safe_top_menu_label'>
              <span><i class='fa fa-hdd-o fa-2x'></i></span>
              <span class='ellipsis safe_top_menu_label_text'>Storage</span>
            </div>
          </a>
        </div>
        <div id='storage_status_details' class='safe_dialog ui-widget' style='width: 300px;'>
          <div id='storage_fs_details' style='float:left; width:50%;'>
            <p class='safe_stats_table_title'>File System</p>
            <table class='safe_stats_table'>
            </table>
          </div>
          <div id='storage_raid_details' style='float:left; width:50%;'>
            <p class='safe_stats_table_title'>RAID</p>
            <table class='safe_stats_table'>
            </table>
          </div>
        </div>
      </li>
      <!--
      <li>
        <div class='safe_dialog_container'>
          <div class='safe_dropdown_arrow_up'></div>
          <div class='safe_top_menu_label safe_plot_container'>
            <div id='top_plot_pie_system_cpu' class='safe_top_menu_plot css_left'>
            </div>
          <span class='ellipsis safe_top_menu_label_text'>CPU</span>
          </div>
        </div>
        <div id='storage_status_details' class='safe_dialog ui-widget' style='width:150px;'>
          <table class='safe_stats_table'>
          </table>
        </div>
      </li>
      <li>
        <div class='safe_dialog_container'>
          <div class='safe_dropdown_arrow_up'></div>
          <div class='safe_top_menu_label safe_plot_container'>
            <div id='top_plot_pie_system_memory' class='safe_top_menu_plot css_left'>
            </div>
            <span class='ellipsis safe_top_menu_label_text'>Memory</span>
          </div>
        </div>
        <div id='safe_top_memory_details' class='safe_dialog ui-widget' style='width:150px;'>
          <table class='safe_stats_table'>
          </table>
        </div>
      </li>
      -->
      <li>
        <div class='safe_dialog_container'>
          <a href='".$safe_top_menu_url['events']."'>
            <div class='safe_dropdown_arrow_up'></div>
            <!-- Configuration status div display, includes a red/green led icon and a status string -->
            <div id='notification_status' class='safe_top_menu_label'>
              <span><i class='fa fa-bell fa-2x'></i></span>
              <span class='ellipsis safe_top_menu_label_text'>Events</span>
            </div>
          </a>
        </div>
        <div id='notification_status_details' class='safe_dialog ui-widget' style='width: 250px;'>
          <table class='safe_stats_table'>
          </table>
        </div>
      </li>
      <li>
        <div class='safe_dialog_container'>
          <a href='".$safe_top_menu_url['configuration']."'>
            <div class='safe_dropdown_arrow_up'></div>
            <!-- Configuration status div display, includes a red/green led icon and a status string -->
            <div id='config_status' class='safe_top_menu_label'>
              <span><i class='fa fa-cogs fa-2x'></i></span>
              <span class='ellipsis safe_top_menu_label_text'>Configuration</span>
            </div>
          </a>
        </div>
        <div id='config_status_dialog' class='safe_dialog ui-widget' style='min-width:250px;'>
        </div>
      </li>
      <li>
        <a href='".$safe_top_menu_url['application']."'>
        <div class='safe_dialog_container'>
          <!-- System status div display, includes a red/green led icon and a status string -->
          <div class='safe_dropdown_arrow_up'></div>
          <div id='system_status' class='safe_top_menu_label'>
            <span><i class='fa fa-bullseye fa-2x'></i></span>
            <span class='ellipsis safe_top_menu_label_text'>Services</span>
          </div>
        </div>
        <div id='application_status_dialog' class='safe_dialog ui-widget'
        style='right:10px; min-width:250px;'>
            <p class='safe_stats_table_title'>Services</p>
          <table class='safe_status_table'>
          </table>
        </div>
        </a>
      </li>
      <!-- Update checker status -->
      <li>
        <a href='".$safe_top_menu_url['update']."'>
        <div class='safe_dialog_container'>
          <div class='safe_dropdown_arrow_up'></div>
          <div id='update_checker_status' class='safe_top_menu_label'>
            <span><i class='fa fa-refresh fa-2x'></i></span>
            <span class='ellipsis safe_top_menu_label_text'>Update</span>
          </div>
        </div>
        <div id='update_status_dialog' class='safe_dialog ui-widget'
        style='right:10px; min-width:250px;'>
            <p class='safe_stats_table_title'>Update</p>
          <table class='safe_status_table'>
          </table>
        </div>
        </a>
      </li>
      <li>
        <div class='safe_dialog_container'>
          <div class='safe_dropdown_arrow_up'></div>
          <div class='safe_top_menu_label icon_button' title='".$user_name."'>
            <span><i class='fa
            fa-user".(('root'==$_SESSION['user_login'])?"s":"")." fa-2x'></i></span>
          </div>
        </div>
        <div class='safe_dropdown ui-widget' style='width:95px;'>
          <ul>
            <a href='/SAFe/sng_user_config/edit/system/user/".$_SESSION['user_login']."'>
            <li class='safe_dropdown_item'>
              <span><i class='fa fa-cog'></i></span>
              <span>Settings</span>
            </li>
            </a>
            <a href='?reserved_logout=y'>
            <li class='safe_dropdown_item'>
              <span><i class='fa fa-sign-out'></i></span>
              <span>Logout</span>
            </li>
              </a>
          </ul>
        </div>
      </li>
      <li>
        <div class='safe_dialog_container'>
          <div class='safe_dropdown_arrow_up'></div>
          <div id='reboot_status' class='safe_top_menu_label icon_button'>
            <span><i class='fa fa-power-off fa-2x'></i></span>
          </div>
        </div>
        <div class='safe_dropdown ui-widget'>
          <ul style='width:120px; left: -52px;'>
            <a href='#' onclick='safe_restart()' id='safe_restart' >
            <li class='safe_dropdown_item'>
              <span><i class='fa fa-repeat'></i></span>
              <span>Restart</span>
            </li>
            </a>
            <a href='#' onclick='safe_poweroff()' id='safe_poweroff' >
            <li class='safe_dropdown_item'>
              <span><i class='fa fa-power-off'></i></span>
              <span>Power Off</span>
            </li>
              </a>
          </ul>
        </div>
      </li>
    </ul>
  </div>
</div>
<!-- LEFT menu -->
<div id='safe_left_menu'>
  $safe_menu_html
</div>
<script>
$(function() {
  var dialog = $( '#dialog_network_capture' ).dialog({
    autoOpen: false,
    modal: true,
    position: 'center',
    modal: true,
    width: 800,
    height: 300,
    draggable: true,
    resizable: false,
    dialogClass: 'msgbox',
    title: 'Network Capture'
  });
  $('#network_capture').on('click',function() {
    $('#dialog_network_capture').dialog('open');
    $('#dialog_network_capture').css('height', '300px');
    iframe = $('#frame_network_capture').contents().find('html')[0];
    $(iframe).find('#safe_header').remove();
    $(iframe).find('#safe_left_menu').remove();
    $(iframe).find('#safe_breadcrumb').remove();
    $(iframe).find('#safe_footer').remove();
    $(iframe).find('#safe_content').css('margin-top', '0px')
    $(iframe).find('#safe_content').css('margin-left', '0px');
  });
  $($('#frame_wait_message')[0]).hide();
});
</script>";
echo $safe_header;
?>
